//***************************************************************************//
//*                                                                         *//
//* Unit:    drj_MainForm                                                   *//
//* Author:  Dark Magus                                                     *//
//*          ColoneL                                                        *//
//* Date:    13.08.01                                                       *//
//*                                                                         *//
//*        Dream Journal (v. 2.0).       *//
//*                                                                         *//
//***************************************************************************//
unit drj_MainForm;

{ DONE 2 -cMethod -oDark Magus :       ,   HTML-    TSynEdit           . }
{ DONE 2 -cAlgorithm oDark Magus :         FINIFile       FLibraryFile. }

//-[ INTERFACE ]---------------------------------------------------------------
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ImgList, StdCtrls, Buttons, Menus, SynEdit, SynEditHighlighter,
  SynHighlighterHtml, SHDocVw, ShellAPI, OleCtrls, ComCtrls,

  colonel_Utility,

  drj_AboutForm,
  drj_NewElementForm,
  drj_Resources,
  drj_Types,
  drj_JournalHash,
  drj_XMLPairList,
  drj_AuthorizationForm,
  drj_Codec,
  drj_ConfirmationForm,
  drj_GraphPainter,
  drj_ParametersForm,
  drj_UserForm,
  drj_FormRenderer,
  drj_Exporter,
  drj_HTMLExporter,
  drj_TXTExporter,

  xml_mainUnit,
  xml_Node,
  xml_Types,
  xml_Functions;

type Tfrm_MainForm = class (TForm)
    bvl_Border             : TBevel;
    box_Label2             : TCheckBox;
    box_Label1             : TCheckBox;
    box_Label4             : TCheckBox;
    box_Label3             : TCheckBox;
    btn_ReadOnly           : TCheckBox;
    edt_Name               : TEdit;
    edt_Number             : TEdit;
    img_Graphs             : TImage;
    img_Image              : TImage;
    iml_TreeImages         : TImageList;
    lbl_Comment            : TLabel;
    lbl_Description        : TLabel;
    lbl_Energy             : TLabel;
    lbl_Image              : TLabel;
    lbl_Name               : TLabel;
    lbl_Number             : TLabel;
    lbl_HighEnergyLevel    : TLabel;
    lbl_LowEnergyLevel     : TLabel;
    lbl_ZeroEnergyLevel    : TLabel;
    mmo_Comment            : TMemo;
    mmo_Description        : TMemo;
    mnu_Create             : TPopupMenu;
    mnu_CreateCatalogue    : TMenuItem;
    mnu_CreateJournal      : TMenuItem;
    mnu_CreateNight        : TMenuItem;
    mnu_CreateExperience   : TMenuItem;
    dlg_OpenImage          : TOpenDialog;
    dlg_Save               : TSaveDialog;
    pnl_Tools              : TPanel;
    pnl_WorkArea           : TPanel;
    btn_Authorization      : TSpeedButton;
    btn_ClearImage         : TSpeedButton;
    btn_Create             : TSpeedButton;
    btn_Delete             : TSpeedButton;
    btn_DreamProperties    : TSpeedButton;
    btn_LoadImage          : TSpeedButton;
    btn_MoveUp             : TSpeedButton;
    btn_MoveDown           : TSpeedButton;
    btn_New                : TSpeedButton;
    btn_Open               : TSpeedButton;
    btn_Save               : TSpeedButton;
    btn_Copy_1             : TSpeedButton;
    btn_Copy_2             : TSpeedButton;
    btn_Copy_3             : TSpeedButton;
    btn_Refresh_1          : TSpeedButton;
    btn_Refresh_2          : TSpeedButton;
    btn_Refresh_3          : TSpeedButton;
    btn_Tool_05            : TSpeedButton;
    btn_Tool_06            : TSpeedButton;
    btn_ViewInBrowser      : TSpeedButton;
    spt_Splitter           : TSplitter;
    trb_Energy             : TTrackBar;
    tre_Directory          : TTreeView;

    pgc_HTMLEditor         : TPageControl;
    pnl_HTMLEditor         : TPanel;
    pnl_HTMLEditorTools    : TPanel;
    pnl_HTMLViewer         : TPanel;
    syn_HTMLHighlighter    : TSynHTMLSyn;
    syn_Editor             : TSynEdit;
    tab_Editor             : TTabSheet;
    tab_Viewer             : TTabSheet;
    web_HTMLViewer         : TWebBrowser;
    btn_HTML_New           : TSpeedButton;
    btn_HTML_Save          : TSpeedButton;
    btn_HTML_Undo          : TSpeedButton;
    btn_HTML_Bold          : TSpeedButton;
    btn_HTML_Italic        : TSpeedButton;
    btn_HTML_Underlined    : TSpeedButton;
    btn_HTML_P             : TSpeedButton;
    btn_HTML_BR            : TSpeedButton;
    btn_HTML_A             : TSpeedButton;
    btn_HTML_IMG           : TSpeedButton;

    mnu_Main               : TMainMenu;
    mnu_File               : TMenuItem;
    mnu_Edit               : TMenuItem;
    mnu_View               : TMenuItem;
    mnu_Help               : TMenuItem;
    mnu_New                : TMenuItem;
    mnu_Open               : TMenuItem;
    mnu_Save               : TMenuItem;
    mnu_SaveAs             : TMenuItem;
    mnu_Separator_1        : TMenuItem;
    mnu_Export             : TMenuItem;
    mnu_Separator_2        : TMenuItem;
    mnu_Authorization      : TMenuItem;
    mnu_Options            : TMenuItem;
    mnu_Separator_3        : TMenuItem;
    mnu_Exit               : TMenuItem;
    mnu_CreateCatalogue_1  : TMenuItem;
    mnu_CreateJournal_1    : TMenuItem;
    mnu_CreateNight_1      : TMenuItem;
    mnu_CreateExperience_1 : TMenuItem;
    mnu_Separator_4        : TMenuItem;
    mnu_MoveUp             : TMenuItem;
    mnu_MoveDown           : TMenuItem;
    mnu_Delete             : TMenuItem;
    mnu_ViewAsHTML         : TMenuItem;
    mnu_RefreshAll         : TMenuItem;
    mnu_ShowHelp           : TMenuItem;
    mnu_Register           : TMenuItem;
    mnu_Internet           : TMenuItem;
    mnu_Separator_5        : TMenuItem;
    mnu_About              : TMenuItem;

    procedure FormCreate (Sender : TObject);
    procedure FormDestroy (Sender: TObject);
    procedure btn_Tool_06Click (Sender : TObject);
    procedure edt_NumberChange (Sender : TObject);
    procedure edt_NameChange (Sender : TObject);
    procedure mmo_DescriptionChange (Sender : TObject);
    procedure mmo_CommentChange (Sender : TObject);
    procedure box_Label1Click (Sender : TObject);
    procedure box_Label2Click (Sender : TObject);
    procedure box_Label3Click (Sender : TObject);
    procedure box_Label4Click (Sender : TObject);
    procedure btn_LoadImageClick (Sender : TObject);
    procedure btn_ClearImageClick (Sender : TObject);
    procedure btn_Tool_05Click (Sender : TObject);
    procedure btn_SaveClick (Sender : TObject);
    procedure btn_ReadOnlyClick (Sender : TObject);
    procedure btn_Tool_01Click (Sender : TObject);
    procedure btn_Tool_02Click (Sender : TObject);
    procedure btn_Tool_03Click (Sender : TObject);
    procedure btn_Tool_04Click (Sender : TObject);
    procedure trb_EnergyChange (Sender : TObject);
    procedure lbl_HighEnergyLevelDblClick (Sender : TObject);
    procedure lbl_ZeroEnergyLevelDblClick (Sender : TObject);
    procedure lbl_LowEnergyLevelDblClick (Sender : TObject);
    procedure FormResize (Sender : TObject);
    procedure btn_AuthorizationClick (Sender : TObject);
    procedure btn_MoveUpClick (Sender : TObject);
    procedure btn_MoveDownClick (Sender : TObject);
    procedure btn_DeleteClick (Sender : TObject);
    procedure tre_DirectoryChanging (Sender : TObject; Node : TTreeNode; var AllowChange : Boolean);
    procedure btn_Refresh_1Click (Sender : TObject);
    procedure btn_Refresh_2Click (Sender : TObject);
    procedure btn_Refresh_3Click (Sender : TObject);
    procedure btn_CreateClick (Sender : TObject);
    procedure pgc_HTMLEditorChanging (Sender : TObject; var AllowChange : Boolean);
    procedure btn_HTML_NewClick (Sender : TObject);
    procedure btn_HTML_SaveClick (Sender : TObject);
    procedure btn_HTML_UndoClick (Sender : TObject);
    procedure btn_HTML_BoldClick (Sender : TObject);
    procedure btn_HTML_ItalicClick (Sender : TObject);
    procedure btn_HTML_UnderlinedClick (Sender : TObject);
    procedure btn_HTML_PClick (Sender : TObject);
    procedure btn_HTML_BRClick (Sender : TObject);
    procedure btn_HTML_AClick (Sender : TObject);
    procedure btn_HTML_IMGClick (Sender : TObject);
    procedure btn_ViewInBrowserClick (Sender : TObject);
    procedure btn_NewClick (Sender : TObject);
    procedure btn_OpenClick (Sender : TObject);
    procedure mnu_SaveAsClick (Sender : TObject);
    procedure mnu_OptionsClick (Sender : TObject);
    procedure btn_DreamPropertiesClick (Sender : TObject);
    procedure mnu_RefreshAllClick (Sender : TObject);
    procedure mnu_ExportClick (Sender : TObject);
    procedure mnu_ShowHelpClick (Sender : TObject);
    procedure mnu_RegisterClick (Sender : TObject);
    procedure mnu_InternetClick (Sender : TObject);

  private
    FTag                  : Boolean;
    FConfirmDelete        : Boolean;
    FExperienceView       : Integer;
    FNextExperienceNumber : Integer;
    FApplicationPath      : String;
    FINIFile              : TXMLParser;
    FLibraryFile          : TXMLParser;
    FHashTable            : TJournalHash;
    FSelectedTreeNode     : TTreeNode;
    FCurrentFileNode      : TXMLNode;
    FXMLPairList          : TXMLPairList;
    FGraphPainter_1       : TDJGraph;
    FGraphPainter_2       : TDJGraph;
    FGraphPainter_3       : TDJGraph;
    FDreamPropertiesForm  : Tfrm_DreamProperties;

    procedure ProcessINIFile;
    procedure ConvertXMLNodeToTreeNode (treeNode : TTreeNode; xmlNode : TXMLNode);
    procedure SetVisibilityOfControls (flag : TControlsFlag);
    procedure FillIn (flag : TControlsFlag; sourceNode : TXMLNode);
    procedure MakeNodeReadOnly;
    procedure MakeNodeWritable;
    procedure CountNumberOfDreams (journalNode : TXMLNode);
    procedure DrawJournalGraphs (treeNode : TTreeNode);
    procedure DrawDayGraphs (treeNode : TTreeNode);
    procedure DrawDirectoryGraphs (treeNode : TTreeNode);
    procedure DrawDirectoryGraph (treeNode : TTreeNode; iType : TYearStatistic);
    procedure SetEditorText (s : String);
    procedure PaintMonthGraph_1;
    procedure PaintMonthGraph_2;
    procedure PaintDayGraph_1;
    procedure PaintYearGraph_1;
    procedure PaintYearGraph_2;
    procedure PaintYearGraph_3;
    procedure InitializeGraphs;
    procedure SetExperienceView (iValue : Integer);
    procedure CollectYearStatistic (iType : TYearStatistic; var xmlNode : TXMLNode);
    procedure FillHTMLEditor (sourceNode : TXMLNode);
    procedure MakeReadyHTMLEditor;
    procedure SetHTMLEditorText (fileName : String);
    procedure InsertTags (tag1, tag2 : String);
    procedure ProcessLibraryFile (fileName : String);

    function GetEditorText : String;
    function BooleanToString (iValue : Boolean) : String;
    function GetNumberOfDreams (xmlNode : TXMLNode) : Integer;
    function GetNewHTMLFileName (id : String) : String;

  public
    property ExperienceView : Integer read FExperienceView write SetExperienceView;

end;

var
  frm_MainForm : Tfrm_MainForm;

//-[ IMPLEMENTATION ]----------------------------------------------------------
implementation

{$R *.DFM}

procedure Tfrm_MainForm.FormCreate (Sender : TObject);
var
  i          : Integer;
  slashIndex : Integer;
begin
  pnl_HTMLEditor.Anchors := [akLeft, akTop, akRight, akBottom];
  pnl_HTMLEditor.Top := 44;
  pnl_HTMLEditor.Left := 5;
  pnl_HTMLEditor.Width := lbl_Energy.Left - 10;
  pnl_HTMLEditor.Height := box_Label1.Top - 60;

  ShortDateFormat := 'dd.mm.yy';
  slashIndex := 1;
  for i := Length (Application.ExeName) downto 1 do
  begin
    if (Application.ExeName[i] = '\') then
    begin
      slashIndex := i;
      Break;
    end;
  end;
  FTag := False;
  FConfirmDelete := True;
  FExperienceView := 0;
  FNextExperienceNumber := 0;
  FApplicationPath := Copy (Application.ExeName, 1, slashIndex);
  FINIFile := TXMLParser.Create;
  FINIFile.XMLParameters.XMLEncoding := XML_ENCODING;
  FINIFile.FileName := FApplicationPath + INI_FILE_NAME;
  FLibraryFile := TXMLParser.Create;
  FLibraryFile.XMLParameters.XMLEncoding := XML_ENCODING;
  FHashTable := TJournalHash.Create;
  FXMLPairList := TXMLPairList.Create;
  FCurrentFileNode := nil;
  FDreamPropertiesForm := Tfrm_DreamProperties.Create (Application);
  dlg_OpenImage.InitialDir := FApplicationPath;
  dlg_Save.InitialDir := FApplicationPath;

  InitializeGraphs;

  ProcessINIFile;
end;

procedure Tfrm_MainForm.FormDestroy (Sender : TObject);
var
  formNode : TXMLNode;
begin
  formNode := FINIFile.XMLRoot.FindTagByName (TAG_FORM);
  if (formNode = nil) then
  begin
    formNode := TXMLNode.Create;
    formNode.TagName := TAG_FORM;
    formNode.TagType := ttShorted;
    FINIFile.XMLRoot.AddChildAsObject (formNode);
    formNode.Level := FINIFile.XMLRoot.Level + 1;
  end;
  formNode.SetAttributeValue (ATTRIBUTE_LEFT, IntToStr (Left));
  formNode.SetAttributeValue (ATTRIBUTE_TOP, IntToStr (Top));
  formNode.SetAttributeValue (ATTRIBUTE_WIDTH, IntToStr (Width));
  formNode.SetAttributeValue (ATTRIBUTE_HEIGHT, IntToStr (Height));
  formNode.SetAttributeValue (ATTRIBUTE_TREE_WIDTH, IntToStr (tre_Directory.Width));
  { DONE 1 -cMethod -oDark Magus :  ,    ,       ,     . }
  FINIFile.SaveFile (FINIFile.FileName);
  FINIFile.Free;
  FLibraryFile.SaveFile (FLibraryFile.FileName);
  FLibraryFile.Free;
  FHashTable.Free;
  FXMLPairList.Free;
  FGraphPainter_1.Free;
  FGraphPainter_2.Free;
  FGraphPainter_3.Free;

  //***************************************************************************
  //   -        
  //      OnResize.     
  // NullPointerException,  FSelectedTreeNode    nil.
  //***************************************************************************
  FSelectedTreeNode := nil;
end;

procedure Tfrm_MainForm.ProcessLibraryFile (fileName : String);
var
  i                 : Integer;
  userName          : String;
  userPassword      : String;
  childNode         : TXMLNode;
  rootNode          : TTreeNode;
  codec             : TCodec;
  authorizationForm : Tfrm_Authorization;
begin
  FLibraryFile.FileName := fileName;

  rootNode := tre_Directory.Items.AddChildFirst (nil, FLibraryFile.XMLRoot.GetAttributeValue (ATTRIBUTE_NAME));
  rootNode.ImageIndex := 1;
  rootNode.Data := FLibraryFile.XMLRoot;

  userName := FLibraryFile.XMLRoot.GetAttributeValue (ATTRIBUTE_USER_NAME);
  userPassword := FLibraryFile.XMLRoot.GetAttributeValue (ATTRIBUTE_USER_PASSWORD);

  if ((userName <> UNDEFINED_VALUE) and (userPassword <> UNDEFINED_VALUE)) then
  begin
    codec := TCodec.Create;
    userName := codec.Decode (userName);
    userPassword := codec.Decode (userPassword);
    codec.Free;
    authorizationForm := Tfrm_Authorization.Create (Application);
    authorizationForm.SetInterface (afGetParameters);
    if (authorizationForm.ShowModal = mrOk) then
    begin
      if ((authorizationForm.edt_First.Text <> userName) or (authorizationForm.edt_Second.Text <> userPassword)) then
      begin
        authorizationForm.Free;
        Application.Terminate;
        Exit;
      end;
    end
    else
    begin
      authorizationForm.Free;
      Application.Terminate;
      Exit;
    end;
    authorizationForm.Free;
  end;

  for i := 0 to FLibraryFile.XMLRoot.GetNumberOfChildren - 1 do
  begin
    childNode := FLibraryFile.XMLRoot.GetChild (i);
    if (childNode.TagName = TAG_DIRECTORY) then
    begin
      ConvertXMLNodeToTreeNode (rootNode, childNode);
      Continue;
    end;
  end;
end;

{ DONE 1 -cMethod -oDark Magus :    INI-   ,       . }
procedure Tfrm_MainForm.ProcessINIFile;
var
  i                 : Integer;
  labelCounter      : Integer;
  iconPath          : String;
  iconName          : String;
  tempString        : String;
  childNode         : TXMLNode;
  tempBitmap        : TBitmap;
  formRenderer      : TFormRenderer;
begin
  labelCounter := 0;

  tempBitmap := TBitmap.Create;
  for i := 0 to FINIFile.XMLRoot.GetNumberOfChildren - 1 do
  begin
    childNode := FINIFile.XMLRoot.Children.Items[i];

    //*** ICON ***//
    if (childNode.TagName = TAG_ICON) then
    begin
      iconPath := childNode.GetAttributeValue (ATTRIBUTE_PATH);
      iconName := childNode.GetAttributeValue (ATTRIBUTE_NAME);
      if (iconPath <> UNDEFINED_VALUE) then
      begin
        tempBitmap.LoadFromFile (iconPath);
        iml_TreeImages.Add (tempBitmap, nil);
      end;

      if (iconName = STR_DREAM_DIRECTORY) then
      begin
        mnu_CreateCatalogue.Bitmap.Assign (tempBitmap);
        mnu_CreateCatalogue_1.Bitmap.Assign (tempBitmap);
        Continue;
      end;
      if (iconName = STR_DREAM_FILE) then
      begin
        mnu_CreateJournal.Bitmap.Assign (tempBitmap);
        mnu_CreateJournal_1.Bitmap.Assign (tempBitmap);
        Continue;
      end;
      if (iconName = STR_ONE_NIGHT) then
      begin
        mnu_CreateNight.Bitmap.Assign (tempBitmap);
        mnu_CreateNight_1.Bitmap.Assign (tempBitmap);
        Continue;
      end;
      if (iconName = STR_ONE_DREAM) then
      begin
        mnu_CreateExperience.Bitmap.Assign (tempBitmap);
        mnu_CreateExperience_1.Bitmap.Assign (tempBitmap);
        Continue;
      end;
    end;

    //*** LABEL ***//
    if (childNode.TagName = TAG_LABEL) then
    begin
      labelCounter := labelCounter + 1;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_CAPTION);
      case (labelCounter) of
        1:
          begin
            box_Label1.Caption := tempString;
            box_Label1.Tag := 1;
          end;
        2:
          begin
            box_Label2.Caption := tempString;
            box_Label2.Tag := 1;
          end;
        3:
          begin
            box_Label3.Caption := tempString;
            box_Label3.Tag := 1;
          end;
        4:
          begin
            box_Label4.Caption := tempString;
            box_Label4.Tag := 1;
          end;
      end;
      Continue;
    end;

    //*** FORM ***//
    if (childNode.TagName = TAG_FORM) then
    begin
      tempString := childNode.GetAttributeValue (ATTRIBUTE_LEFT);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        Left := StrToInt (tempString);
      end;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_TOP);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        Top := StrToInt (tempString);
      end;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_WIDTH);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        Width := StrToInt (tempString);
      end;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_HEIGHT);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        Height := StrToInt (tempString);
      end;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_TREE_WIDTH);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        tre_Directory.Width := StrToInt (tempString);
      end;
      Continue;
    end;

    //*** OPTIONS ***//
    if (childNode.TagName = TAG_OPTIONS) then
    begin
      tempString := childNode.GetAttributeValue (ATTRIBUTE_CONFIRMDELETE);
      if (tempString = STR_YES) then
      begin
        FConfirmDelete := True;
      end;
      if (tempString = STR_NO) then
      begin
        FConfirmDelete := False;
      end;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_EXPERIENCEVIEW);
      if (tempString = HTML_VALUE) then
      begin
        FExperienceView := 1;
      end;
      Continue;
    end;

    //*** LIBRARY ***//
    if (childNode.TagName = TAG_LIBRARY) then
    begin
      tempString := childNode.GetAttributeValue (ATTRIBUTE_PATH);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        ProcessLibraryFile (tempString);
      end;
      Continue;
    end;

    //*** DREAM-FORM ***//
    if (childNode.TagName = TAG_DREAM_FORM) then
    begin
      formRenderer := TFormRenderer.Create;
      formRenderer.CloseFormProcedure := FDreamPropertiesForm.CloseForm;
      formRenderer.CancelFormProcedure := FDreamPropertiesForm.ClickCancel;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_WIDTH);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        FDreamPropertiesForm.Width := StrToInt (tempString);
      end;
      tempString := childNode.GetAttributeValue (ATTRIBUTE_HEIGHT);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        FDreamPropertiesForm.Height := StrToInt (tempString);
      end;

      formRenderer.RenderForm (childNode, FDreamPropertiesForm.pnl_WorkArea);

      formRenderer.Free;
    end;

  end;
  tempBitmap.Free;
end;

procedure Tfrm_MainForm.btn_Tool_06Click (Sender : TObject);
begin
  Close;
end;

procedure Tfrm_MainForm.ConvertXMLNodeToTreeNode (treeNode : TTreeNode; xmlNode : TXMLNode);
var
  i            : Integer;
  xmlAttribute : String;
  childXML     : TXMLNode;
  nextNode     : TTreeNode;
  fileNode     : TTreeNode;
begin
  nextNode := tre_Directory.Items.AddChild (treeNode, xmlNode.GetAttributeValue (ATTRIBUTE_NAME));
  if (xmlNode.TagName = TAG_DAY) then
  begin
   nextNode.ImageIndex := 4;
  end
  else
  begin
   nextNode.ImageIndex := 2;
  end;
  nextNode.Data := xmlNode;

  for i := 0 to xmlNode.GetNumberOfChildren - 1 do
  begin
    childXML := xmlNode.GetChild (i);
    if (childXML.TagName = TAG_DIRECTORY) then
    begin
      ConvertXMLNodeToTreeNode (nextNode, childXML);
      Continue;
    end;
    if (childXML.TagName = TAG_FILE) then
    begin
      fileNode := tre_Directory.Items.AddChild (nextNode, childXML.GetAttributeValue (ATTRIBUTE_NAME));
      fileNode.ImageIndex := 3;
      fileNode.Data := childXML;
      xmlAttribute := childXML.GetAttributeValue (ATTRIBUTE_DEFAULT);
      if (xmlAttribute = STR_YES) then
      begin
        fileNode.Selected := True;
        fileNode.Expand (False);
      end;
      Continue;
    end;
    if (childXML.TagName = TAG_EXPERIENCE) then
    begin
      fileNode := tre_Directory.Items.AddChild (nextNode, childXML.GetAttributeValue (ATTRIBUTE_NUMBER) + NAME_DELIMITER + childXML.GetAttributeValue (ATTRIBUTE_TITLE));
      fileNode.ImageIndex := 5;
      fileNode.Data := childXML;
      Continue;
    end;
  end;
end;

procedure Tfrm_MainForm.SetVisibilityOfControls (flag : TControlsFlag);
begin
  case (flag) of
    cfDreamLibrary:
      begin
        pnl_HTMLEditor.Visible := False;
        btn_DreamProperties.Visible := False;
        img_Graphs.Visible := False;
        lbl_Number.Visible := False;
        lbl_Name.Left := 5;
        lbl_Name.Caption := LABEL_NAME;
        edt_Number.Visible := False;
        edt_Name.Left := 4;
        edt_Name.Width := pnl_WorkArea.Width - 6;
        lbl_Description.Visible := False;
        mmo_Description.Visible := False;
        lbl_Comment.Visible := False;
        mmo_Comment.Visible := False;
        lbl_Image.Visible := False;
        img_Image.Visible := False;
        btn_LoadImage.Visible := False;
        btn_ClearImage.Visible := False;
        box_Label1.Visible := False;
        box_Label2.Visible := False;
        box_Label3.Visible := False;
        box_Label4.Visible := False;
        bvl_Border.Top := 39;
        bvl_Border.Anchors := [akLeft,akRight,akTop];
        btn_ReadOnly.Visible := False;
        trb_Energy.Visible := False;
        lbl_Energy.Visible := False;
        lbl_HighEnergyLevel.Visible := False;
        lbl_ZeroEnergyLevel.Visible := False;
        lbl_LowEnergyLevel.Visible := False;
        btn_Copy_1.Visible := False;
        btn_Copy_2.Visible := False;
        btn_Copy_3.Visible := False;
        btn_Refresh_1.Visible := False;
        btn_Refresh_2.Visible := False;
        btn_Refresh_3.Visible := False;
      end;
    cfDirectory:
      begin
        pnl_HTMLEditor.Visible := False;
        btn_DreamProperties.Visible := False;
        img_Graphs.Visible := True;
        lbl_Number.Visible := False;
        lbl_Name.Left := 5;
        lbl_Name.Caption := LABEL_NAME;
        edt_Number.Visible := False;
        edt_Name.Left := 4;
        edt_Name.Width := pnl_WorkArea.Width - 6;
        lbl_Description.Visible := False;
        mmo_Description.Visible := False;
        lbl_Comment.Visible := False;
        mmo_Comment.Visible := False;
        lbl_Image.Visible := False;
        img_Image.Visible := False;
        btn_LoadImage.Visible := False;
        btn_ClearImage.Visible := False;
        box_Label1.Visible := False;
        box_Label2.Visible := False;
        box_Label3.Visible := False;
        box_Label4.Visible := False;
        bvl_Border.Top := 39;
        bvl_Border.Anchors := [akLeft,akRight,akTop];
        btn_ReadOnly.Visible := False;
        trb_Energy.Visible := False;
        lbl_Energy.Visible := False;
        lbl_HighEnergyLevel.Visible := False;
        lbl_ZeroEnergyLevel.Visible := False;
        lbl_LowEnergyLevel.Visible := False;
        btn_Copy_1.Visible := False;
        btn_Copy_2.Visible := False;
        btn_Copy_3.Visible := False;
        btn_Refresh_1.Visible := False;
        btn_Refresh_2.Visible := False;
        btn_Refresh_3.Visible := False;
      end;
    cfDreamJournal:
      begin
        pnl_HTMLEditor.Visible := False;
        btn_DreamProperties.Visible := False;
        img_Graphs.Visible := True;
        lbl_Number.Visible := False;
        lbl_Name.Left := 5;
        lbl_Name.Caption := LABEL_NAME;
        edt_Number.Visible := False;
        edt_Name.Left := 4;
        edt_Name.Width := pnl_WorkArea.Width - 6;
        lbl_Description.Visible := False;
        mmo_Description.Visible := False;
        lbl_Comment.Visible := False;
        mmo_Comment.Visible := False;
        lbl_Image.Visible := False;
        img_Image.Visible := False;
        btn_LoadImage.Visible := False;
        btn_ClearImage.Visible := False;
        box_Label1.Visible := False;
        box_Label2.Visible := False;
        box_Label3.Visible := False;
        box_Label4.Visible := False;
        bvl_Border.Top := 39;
        bvl_Border.Anchors := [akLeft,akRight,akTop];
        btn_ReadOnly.Visible := False;
        trb_Energy.Visible := False;
        lbl_Energy.Visible := False;
        lbl_HighEnergyLevel.Visible := False;
        lbl_ZeroEnergyLevel.Visible := False;
        lbl_LowEnergyLevel.Visible := False;
        btn_Copy_1.Visible := False;
        btn_Copy_2.Visible := False;
        btn_Copy_3.Visible := False;
        btn_Refresh_1.Visible := False;
        btn_Refresh_2.Visible := False;
        btn_Refresh_3.Visible := False;
      end;
    cfOneNight:
      begin
        pnl_HTMLEditor.Visible := False;
        btn_DreamProperties.Visible := False;
        img_Graphs.Visible := True;
        lbl_Number.Visible := False;
        lbl_Name.Left := 5;
        lbl_Name.Caption := LABEL_DATE;
        edt_Number.Visible := False;
        edt_Name.Left := 4;
        edt_Name.Width := pnl_WorkArea.Width - 6;
        lbl_Description.Visible := False;
        mmo_Description.Visible := False;
        bvl_Border.Top := 39;
        bvl_Border.Anchors := [akLeft,akRight,akTop];
        lbl_Comment.Visible := True;
        lbl_Comment.Left := 10;
        lbl_Comment.Top := ((pnl_WorkArea.Height - (bvl_Border.Top + bvl_Border.Height)) div 2 + 35);
        mmo_Comment.Visible := True;
        mmo_Comment.Left := 10;
        mmo_Comment.Top := (pnl_WorkArea.Height - (bvl_Border.Top + bvl_Border.Height)) div 2 + 40 + lbl_Comment.Height;
        mmo_Comment.Width := pnl_WorkArea.Width - 20;
        mmo_Comment.Height := (pnl_WorkArea.Height - 10) - mmo_Comment.Top;
        lbl_Image.Visible := False;
        img_Image.Visible := False;
        btn_LoadImage.Visible := False;
        btn_ClearImage.Visible := False;
        box_Label1.Visible := False;
        box_Label2.Visible := False;
        box_Label3.Visible := False;
        box_Label4.Visible := False;
        btn_ReadOnly.Visible := False;
        trb_Energy.Visible := False;
        lbl_Energy.Visible := False;
        lbl_HighEnergyLevel.Visible := False;
        lbl_ZeroEnergyLevel.Visible := False;
        lbl_LowEnergyLevel.Visible := False;
        btn_Copy_1.Visible := False;
        btn_Copy_2.Visible := False;
        btn_Copy_3.Visible := False;
        btn_Refresh_1.Visible := False;
        btn_Refresh_2.Visible := False;
        btn_Refresh_3.Visible := False;
      end;
    cfOneDream:
      begin
        pnl_HTMLEditor.Visible := False;
        btn_DreamProperties.Visible := True;
        img_Graphs.Visible := False;
        lbl_Number.Visible := True;
        lbl_Name.Left := 84;
        lbl_Name.Caption := LABEL_NAME;
        edt_Number.Visible := True;
        edt_Name.Left := 83;
        edt_Name.Width := pnl_WorkArea.Width - 85;
        lbl_Description.Visible := True;
        mmo_Description.Visible := True;
        lbl_Comment.Visible := True;
        lbl_Comment.Left := 4;
        lbl_Comment.Top := mmo_description.Top + mmo_Description.Height + 6;
        mmo_Comment.Visible := True;
        mmo_Comment.Left := 4;
        mmo_Comment.Top := lbl_Comment.Top + lbl_Comment.Height + 3;
        mmo_Comment.Height := 64;
        mmo_Comment.Width := pnl_WorkArea.Width - (img_Image.Width + 22);
        lbl_Image.Visible := True;
        img_Image.Visible := True;
        btn_LoadImage.Visible := True;
        btn_ClearImage.Visible := True;
        if (box_Label1.Caption <> '') then
        begin
          box_Label1.Visible := True;
          if (box_Label2.Caption <> '') then
          begin
            box_Label2.Visible := True;
            if (box_Label3.Caption <> '') then
            begin
              box_Label3.Visible := True;
              if (box_Label4.Caption <> '') then
              begin
                box_Label4.Visible := True;
              end;
            end;
          end;
        end;
        bvl_Border.Top := img_Graphs.Height - 39;
        bvl_Border.Anchors := [akLeft,akRight,akBottom];
        btn_ReadOnly.Visible := True;
        trb_Energy.Height := mmo_Description.Height;
        trb_Energy.Visible := True;
        lbl_Energy.Visible := True;
        lbl_HighEnergyLevel.Visible := True;
        lbl_ZeroEnergyLevel.Top := trb_Energy.Top + (trb_Energy.Height - lbl_ZeroEnergyLevel.Height) div 2;
        lbl_ZeroEnergyLevel.Visible := True;
        lbl_LowEnergyLevel.Top := trb_Energy.Top + trb_Energy.Height - lbl_LowEnergyLevel.Height - 6;
        lbl_LowEnergyLevel.Visible := True;
        btn_Copy_1.Visible := False;
        btn_Copy_2.Visible := False;
        btn_Copy_3.Visible := False;
        btn_Refresh_1.Visible := False;
        btn_Refresh_2.Visible := False;
        btn_Refresh_3.Visible := False;
      end;
  end;
end;

procedure Tfrm_MainForm.FillIn (flag : TControlsFlag; sourceNode : TXMLNode);
var
  i          : Integer;
  tempString : String;
  childNode  : TXMLNode;
begin
  case (flag) of
    cfDreamLibrary:
      begin
        tempString := sourceNode.GetAttributeValue (ATTRIBUTE_NAME);
        if (tempString <> UNDEFINED_VALUE) then
        begin
          edt_Name.Text := tempString;
        end
        else
        begin
          edt_Name.Text := '';
        end;
      end;
    cfDirectory:
      begin
        tempString := sourceNode.GetAttributeValue (ATTRIBUTE_NAME);
        if (tempString <> UNDEFINED_VALUE) then
        begin
          edt_Name.Text := tempString;
        end
        else
        begin
          edt_Name.Text := '';
        end;
      end;
    cfDreamJournal:
      begin
        tempString := sourceNode.GetAttributeValue (ATTRIBUTE_NAME);
        if ((sourceNode.TagName = TAG_FILE) and (tempString <> UNDEFINED_VALUE)) then
        begin
          edt_Name.Text := tempString;
        end
        else
        begin
          if (sourceNode.TagName = TAG_DREAMJOURNAL) then
          begin
            childNode := FXMLPairList.FindFileByJournal (sourceNode);
            if (childNode <> nil) then
            begin
              tempString := childNode.GetAttributeValue (ATTRIBUTE_NAME);
              if (tempString <> UNDEFINED_VALUE) then
              begin
                edt_Name.Text := tempString;
              end
              else
              begin
                edt_Name.Text := '';
              end;
            end;
          end;
        end;
      end;
    cfOneNight:
      begin
        tempString := sourceNode.GetAttributeValue (ATTRIBUTE_NAME);
        if (tempString <> UNDEFINED_VALUE) then
        begin
          edt_Name.Text := tempString;
        end
        else
        begin
          edt_Name.Text := '';
        end;

        mmo_Comment.Lines.Clear;
        childNode := nil;
        for i := 0 to sourceNode.GetNumberOfChildren - 1 do
        begin
          childNode := sourceNode.GetChild (i);
          if (childNode.TagName = TAG_COMMENT) then
          begin
            Break;
          end;
          childNode := nil;
        end;
        if ((childNode <> nil) and (childNode.GetChild (0) <> nil)) then
        begin
          mmo_Comment.Text := childNode.GetChild (0).TextData;
        end
        else
        begin
          mmo_Comment.Text := '';
        end;
      end;
    cfOneDream:
      begin
        tempString := sourceNode.GetAttributeValue (ATTRIBUTE_NUMBER);
        if (tempString <> UNDEFINED_VALUE) then
        begin
          edt_Number.Text := tempString;
        end
        else
        begin
          edt_Number.Text := '';
        end;

        tempString := sourceNode.GetAttributeValue (ATTRIBUTE_TITLE);
        if (tempString <> UNDEFINED_VALUE) then
        begin
          edt_Name.Text := tempString;
        end
        else
        begin
          edt_Name.Text := '';
        end;

        childNode := sourceNode.FindTagByName (TAG_DESCRIPTION);
        if ((childNode <> nil) and (childNode.GetChild (0) <> nil)) then
        begin
          SetEditorText (childNode.GetChild (0).TextData);
        end
        else
        begin
          SetEditorText ('');
        end;

        mmo_Comment.Lines.Clear;
        childNode := sourceNode.FindTagByName (TAG_COMMENT);
        if ((childNode <> nil) and (childNode.GetChild (0) <> nil)) then
        begin
          mmo_Comment.Text := childNode.GetChild (0).TextData;
        end;

        childNode := sourceNode.FindTagByName (TAG_IMAGE);
        { DONE 2 -cMethod -oDark Magus :     . }
        img_Image.Picture.LoadFromFile (FApplicationPath + EMPTY_GRAPHIC_FILE);
        if (childNode <> nil) then
        begin
          tempString := childNode.GetAttributeValue (ATTRIBUTE_PATH);
          if (tempString <> UNDEFINED_VALUE) then
          begin
            img_Image.Picture.LoadFromFile (tempString);
          end;
        end;

        childNode := sourceNode.FindTagByName (TAG_PROPERTIES);
        if (childNode <> nil) then
        begin
          tempString := childNode.GetAttributeValue (ATTRIBUTE_LUCIDDREAM);
          if (tempString = UNDEFINED_VALUE) then
          begin
            tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL1);
          end
          else
          begin
            childNode.DeleteAttribute (ATTRIBUTE_LUCIDDREAM);
            childNode.SetAttributeValue (ATTRIBUTE_LABEL1, tempString);
          end;
          if (tempString = TRUE_VALUE) then
          begin
            box_Label1.Checked := True;
          end
          else
          begin
            box_Label1.Checked := False;
            childNode.SetAttributeValue (ATTRIBUTE_LABEL1, FALSE_VALUE);
          end;
          tempString := childNode.GetAttributeValue (ATTRIBUTE_ASTRALPROJECTION);
          if (tempString = UNDEFINED_VALUE) then
          begin
            tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL2);
          end
          else
          begin
            childNode.DeleteAttribute (ATTRIBUTE_ASTRALPROJECTION);
            childNode.SetAttributeValue (ATTRIBUTE_LABEL2, tempString);
          end;
          if (tempString = TRUE_VALUE) then
          begin
            box_Label2.Checked := True;
          end
          else
          begin
            box_Label2.Checked := False;
            childNode.SetAttributeValue (ATTRIBUTE_LABEL2, FALSE_VALUE);
          end;
          tempString := childNode.GetAttributeValue (ATTRIBUTE_OUTOFBODY);
          if (tempString = UNDEFINED_VALUE) then
          begin
            tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL3);
          end
          else
          begin
            childNode.DeleteAttribute (ATTRIBUTE_OUTOFBODY);
            childNode.SetAttributeValue (ATTRIBUTE_LABEL3, tempString);
          end;
          if (tempString = TRUE_VALUE) then
          begin
            box_Label3.Checked := True;
          end
          else
          begin
            box_Label3.Checked := False;
            childNode.SetAttributeValue (ATTRIBUTE_LABEL3, FALSE_VALUE);
          end;
          tempString := childNode.GetAttributeValue (ATTRIBUTE_OTHEREXPERIENCE);
          if (tempString = UNDEFINED_VALUE) then
          begin
            tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL4);
          end
          else
          begin
            childNode.DeleteAttribute (ATTRIBUTE_OTHEREXPERIENCE);
            childNode.SetAttributeValue (ATTRIBUTE_LABEL4, tempString);
          end;
          if (tempString = TRUE_VALUE) then
          begin
            box_Label4.Checked := True;
          end
          else
          begin
            box_Label4.Checked := False;
            childNode.SetAttributeValue (ATTRIBUTE_LABEL4, FALSE_VALUE);
          end;
        end
        else
        begin
          box_Label1.Checked := False;
          box_Label2.Checked := False;
          box_Label3.Checked := False;
          box_Label4.Checked := False;
        end;

        childNode := sourceNode.FindTagByName (TAG_ENERGY);
        if (childNode <> nil) then
        begin
          tempString := childNode.GetAttributeValue (ATTRIBUTE_LEVEL);
          if (tempString <> UNDEFINED_VALUE) then
          begin
            trb_Energy.Position := StrToInt (tempString);
            if ((trb_Energy.Position > (trb_Energy.Max - trb_Energy.PageSize) div 2) and (trb_Energy.Position < (trb_Energy.Max + trb_Energy.PageSize) div 2)) then
            begin
              lbl_ZeroEnergyLevel.Font.Color := clRed;
            end;
          end;
        end
        else
        begin
          trb_Energy.Position := trb_Energy.Max div 2;
          lbl_ZeroEnergyLevel.Font.Color := clRed;
        end;
      end;
  end;
end;

procedure Tfrm_MainForm.edt_NumberChange (Sender : TObject);
var
  nodeName   : String;
  sourceNode : TXMLNode;
begin
  nodeName := FSelectedTreeNode.Text;
  sourceNode := FSelectedTreeNode.Data;
  sourceNode.SetAttributeValue (ATTRIBUTE_NUMBER, edt_Number.Text);
  FSelectedTreeNode.Text := edt_Number.Text + Copy (nodeName, Pos (NAME_DELIMITER, nodeName), Length (nodeName) - Pos (NAME_DELIMITER, nodeName) + 1);
end;

procedure Tfrm_MainForm.edt_NameChange (Sender : TObject);
var
  nodeName    : String;
  nodeTagName : String;
  sourceNode  : TXMLNode;
  fileNode    : TXMLNode;
begin
  nodeName := FSelectedTreeNode.Text;
  sourceNode := FSelectedTreeNode.Data;
  nodeTagName := sourceNode.TagName;
  if ((nodeTagName = TAG_DREAMLIBRARY) or (nodeTagName = TAG_DIRECTORY) or (nodeTagName = TAG_FILE) or (nodeTagName = TAG_DAY)) then
  begin
    sourceNode.SetAttributeValue (ATTRIBUTE_NAME, edt_Name.Text);
    FSelectedTreeNode.Text := edt_Name.Text;
    Exit;
  end;
  if (nodeTagName = TAG_DREAMJOURNAL) then
  begin
    filenode := FXMLPairList.FindFileByJournal (sourceNode);
    if (fileNode <> nil) then
    begin
      fileNode.SetAttributeValue (ATTRIBUTE_NAME, edt_Name.Text);
      FSelectedTreeNode.Text := edt_Name.Text;
    end;
    Exit;
  end;
  sourceNode.SetAttributeValue (ATTRIBUTE_TITLE, edt_Name.Text);
  FSelectedTreeNode.Text := Copy (nodeName, 1, Pos (NAME_DELIMITER, nodeName) - 1 + Length (NAME_DELIMITER)) + edt_Name.Text;
end;

procedure Tfrm_MainForm.mmo_DescriptionChange (Sender : TObject);
var
  sourceNode      : TXMLNode;
  descriptionNode : TXMLNode;
  childNode       : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  descriptionNode := sourceNode.FindTagByName (TAG_DESCRIPTION);
  if (descriptionNode = nil) then
  begin
    descriptionNode := TXMLNode.Create;
    descriptionNode.TagName := TAG_DESCRIPTION;
    sourceNode.AddChildAsObject (descriptionNode);
    descriptionNode.Level := sourceNode.Level + 1;
  end;
  if (descriptionNode.GetChild (0) = nil) then
  begin
    childNode := TXMLNode.Create;
    descriptionNode.AddChildAsObject (childNode);
  end
  else
  begin
    childNode := descriptionNode.GetChild (0);
  end;
  childNode.TagType := ttCDATA;
  childNode.TextData := '';
  childNode.TextData := TrimSpaces (GetEditorText);
end;

procedure Tfrm_MainForm.mmo_CommentChange (Sender : TObject);
var
  i           : Integer;
  tempString  : String;
  sourceNode  : TXMLNode;
  commentNode : TXMLNode;
  childNode   : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  commentNode := nil;
  for i := 0 to sourceNode.GetNumberOfChildren - 1 do
  begin
    commentNode := sourceNode.GetChild (i);
    if (commentNode.TagName = TAG_COMMENT) then
    begin
      Break;
    end;
    commentNode := nil;
  end;
  if (commentNode = nil) then
  begin
    commentNode := TXMLNode.Create;
    commentNode.TagName := TAG_COMMENT;
    sourceNode.AddChildAsObject (commentNode);
    commentNode.Level := sourceNode.Level + 1;
  end;
  if (commentNode.GetChild (0) = nil) then
  begin
    childNode := TXMLNode.Create;
    commentNode.AddChildAsObject (childNode);
  end
  else
  begin
    childNode := commentNode.GetChild (0);
  end;
  childNode.TagType := ttCDATA;
  childNode.TextData := '';
  tempString := '';
  for i := 0 to (Sender as TMemo).Lines.Count - 1 do
  begin
    tempString := tempString + (Sender as TMemo).Lines[i] + ' ';
  end;
  childNode.TextData := TrimSpaces (tempString);
end;

procedure Tfrm_MainForm.box_Label1Click (Sender : TObject);
var
  sourceNode     : TXMLNode;
  propertiesNode : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  propertiesNode := sourceNode.FindTagByName (TAG_PROPERTIES);
  if (propertiesNode = nil) then
  begin
    propertiesNode := TXMLNode.Create;
    propertiesNode.TagName := TAG_PROPERTIES;
    propertiesNode.TagType := ttShorted;
    sourceNode.AddChildAsObject (propertiesNode);
    propertiesNode.Level := sourceNode.Level + 1;
  end;
  propertiesNode.SetAttributeValue (ATTRIBUTE_LABEL1, BooleanToString ((Sender as TCheckBox).Checked));
end;

procedure Tfrm_MainForm.box_Label2Click (Sender : TObject);
var
  sourceNode     : TXMLNode;
  propertiesNode : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  propertiesNode := sourceNode.FindTagByName (TAG_PROPERTIES);
  if (propertiesNode = nil) then
  begin
    propertiesNode := TXMLNode.Create;
    propertiesNode.TagName := TAG_PROPERTIES;
    propertiesNode.TagType := ttShorted;
    sourceNode.AddChildAsObject (propertiesNode);
    propertiesNode.Level := sourceNode.Level + 1;
  end;
  propertiesNode.SetAttributeValue (ATTRIBUTE_LABEL2, BooleanToString ((Sender as TCheckBox).Checked));
end;

procedure Tfrm_MainForm.box_Label3Click (Sender : TObject);
var
  sourceNode     : TXMLNode;
  propertiesNode : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  propertiesNode := sourceNode.FindTagByName (TAG_PROPERTIES);
  if (propertiesNode = nil) then
  begin
    propertiesNode := TXMLNode.Create;
    propertiesNode.TagName := TAG_PROPERTIES;
    propertiesNode.TagType := ttShorted;
    sourceNode.AddChildAsObject (propertiesNode);
    propertiesNode.Level := sourceNode.Level + 1;
  end;
  propertiesNode.SetAttributeValue (ATTRIBUTE_LABEL3, BooleanToString ((Sender as TCheckBox).Checked));
end;

procedure Tfrm_MainForm.box_Label4Click (Sender : TObject);
var
  sourceNode     : TXMLNode;
  propertiesNode : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  propertiesNode := sourceNode.FindTagByName (TAG_PROPERTIES);
  if (propertiesNode = nil) then
  begin
    propertiesNode := TXMLNode.Create;
    propertiesNode.TagName := TAG_PROPERTIES;
    propertiesNode.TagType := ttShorted;
    sourceNode.AddChildAsObject (propertiesNode);
    propertiesNode.Level := sourceNode.Level + 1;
  end;
  propertiesNode.SetAttributeValue (ATTRIBUTE_LABEL4, BooleanToString ((Sender as TCheckBox).Checked));
end;

function Tfrm_MainForm.BooleanToString (iValue : Boolean) : String;
begin
  Result := FALSE_VALUE;
  if (iValue) then
  begin
    Result := TRUE_VALUE;
  end;
end;

procedure Tfrm_MainForm.btn_LoadImageClick (Sender : TObject);
var
  sourceNode : TXMLNode;
  imageNode  : TXMLNode;
begin
  if (dlg_OpenImage.Execute) then
  begin
    img_Image.Picture.LoadFromFile (dlg_OpenImage.FileName);
    sourceNode := FSelectedTreeNode.Data;
    imageNode := sourceNode.FindTagByName (TAG_IMAGE);
    if (imageNode = nil) then
    begin
      imageNode := TXMLNode.Create;
      imageNode.TagName := TAG_IMAGE;
      imageNode.TagType := ttShorted;
      sourceNode.AddChildAsObject (imageNode);
      imageNode.Level := sourceNode.Level + 1;
    end;
    imageNode.SetAttributeValue (ATTRIBUTE_PATH, dlg_OpenImage.FileName);
  end;
end;

procedure Tfrm_MainForm.btn_ClearImageClick (Sender : TObject);
var
  sourceNode : TXMLNode;
  imageNode  : TXMLNode;
begin
  img_Image.Picture.LoadFromFile (FApplicationPath + EMPTY_GRAPHIC_FILE);
  sourceNode := FSelectedTreeNode.Data;
  imageNode := sourceNode.FindTagByName (TAG_IMAGE);
  if (imageNode <> nil) then
  begin
    if (imageNode.GetAttributeValue (ATTRIBUTE_PATH) <> UNDEFINED_VALUE) then
    begin
      imageNode.SetAttributeValue (ATTRIBUTE_PATH, UNDEFINED_VALUE);
    end;
  end;
end;

procedure Tfrm_MainForm.btn_Tool_05Click (Sender : TObject);
var
  tempForm : Tfrm_About;
begin
  tempForm := Tfrm_About.Create (Application);
  tempForm.ShowModal;
  tempForm.Free;
end;

procedure Tfrm_MainForm.btn_SaveClick (Sender : TObject);
begin
  FINIFile.SaveFile (FINIFile.FileName);
  FLibraryFile.SaveFile (FLibraryFile.FileName);
  FHashTable.SaveAll;
end;

procedure Tfrm_MainForm.btn_ReadOnlyClick (Sender : TObject);
var
  xmlNode    : TXMLNode;
begin
  // --*--  ColoneL' 15.11.2001 --*--
  {
  xmlNode := FSelectedTreeNode.Data;
  xmlNode.SetAttributeValue (ATTRIBUTE_READONLY, TRUE_VALUE);
  MakeNodeReadOnly;
  }
  // --*--  Dark Magus' 21.11.2001 --*--
  {
        NIGHT,    type = "html".
         .
  }

  xmlNode := FSelectedTreeNode.Data;
  case btn_ReadOnly.Checked of
    True:
      begin
        xmlNode.SetAttributeValue (ATTRIBUTE_READONLY, TRUE_VALUE);
        MakeNodeReadOnly;
      end;
    False:
      begin
        xmlNode.SetAttributeValue (ATTRIBUTE_READONLY, FALSE_VALUE);
        MakeNodeWritable;
      end;
  end;
  // --*--   --*--
end;

procedure Tfrm_MainForm.MakeNodeReadOnly;
var
  xmlNode    : TXMLNode;
begin
  xmlNode := FSelectedTreeNode.Data;
  if (xmlNode.GetAttributeValue (ATTRIBUTE_TYPE) = HTML_VALUE) then
  begin
    edt_Number.ReadOnly := True;
    edt_Name.ReadOnly := True;
    box_Label1.Enabled := False;
    box_Label2.Enabled := False;
    box_Label3.Enabled := False;
    box_Label4.Enabled := False;
    trb_Energy.Enabled := False;
    tab_Editor.Enabled := False;
    btn_ReadOnly.Checked := True;
  end
  else
  begin
    edt_Number.ReadOnly := True;
    edt_Name.ReadOnly := True;
    mmo_Description.ReadOnly := True;
    mmo_Comment.ReadOnly := True;
    btn_LoadImage.Visible := False;
    btn_ClearImage.Visible := False;
    box_Label1.Enabled := False;
    box_Label2.Enabled := False;
    box_Label3.Enabled := False;
    box_Label4.Enabled := False;
    trb_Energy.Enabled := False;
    // --*--  ColoneL' 15.11.2001 --*--
    btn_ReadOnly.Checked := True;
    //  btn_ReadOnly.Visible := False;
    // --*--   --*--
  end;
end;

procedure Tfrm_MainForm.MakeNodeWritable;
var
  xmlNode    : TXMLNode;
begin
  xmlNode := FSelectedTreeNode.Data;
  if (xmlNode.GetAttributeValue (ATTRIBUTE_TYPE) = HTML_VALUE) then
  begin
    edt_Number.ReadOnly := False;
    edt_Name.ReadOnly := False;
    box_Label1.Enabled := True;
    box_Label2.Enabled := True;
    box_Label3.Enabled := True;
    box_Label4.Enabled := True;
    trb_Energy.Enabled := True;
    tab_Editor.Enabled := True;
    btn_ReadOnly.Checked := False;
  end
  else
  begin
    edt_Number.ReadOnly := False;
    edt_Name.ReadOnly := False;
    mmo_Description.ReadOnly := False;
    mmo_Comment.ReadOnly := False;
    btn_LoadImage.Visible := True;
    btn_ClearImage.Visible := True;
    box_Label1.Enabled := True;
    box_Label2.Enabled := True;
    box_Label3.Enabled := True;
    box_Label4.Enabled := True;
    trb_Energy.Enabled := True;
    // --*--  ColoneL' 15.11.2001 --*--
    btn_ReadOnly.Checked := False;
    //  btn_ReadOnly.Visible := True;
    // --*--   --*--
  end;
end;

procedure Tfrm_MainForm.btn_Tool_01Click (Sender : TObject);
var
  newElementForm : Tfrm_NewElement;
  xmlNode        : TXMLNode;
  parentNode     : TXMLNode;
  newTreeNode    : TTreeNode;
begin
  newElementForm := Tfrm_NewElement.Create (Application);
  newElementForm.SetInterface (cfDirectory);
  if (newElementForm.ShowModal = mrOk) then
  begin
    parentNode := FSelectedTreeNode.Data;
    xmlNode := TXMLNode.Create;
    xmlNode.TagName := TAG_DIRECTORY;
    xmlNode.SetAttributeValue (ATTRIBUTE_NAME, newElementForm.edt_First.Text);
    parentNode.AddChildAsObject (xmlNode);
    xmlNode.Level := parentNode.Level + 1;
    newTreeNode := tre_Directory.Items.AddChild (FSelectedTreeNode, newElementForm.edt_First.Text);
    newTreeNode.ImageIndex := 2;
    newTreeNode.Data := xmlNode;
    FSelectedTreeNode.Expand (False);
    newTreeNode.Selected := True;
  end;
  newElementForm.Free;
end;

procedure Tfrm_MainForm.btn_Tool_02Click (Sender : TObject);
var
  newElementForm : Tfrm_NewElement;
  newXMLParser   : TXMLParser;
  xmlNode        : TXMLNode;
  parentNode     : TXMLNode;
  newTreeNode    : TTreeNode;
begin
  newElementForm := Tfrm_NewElement.Create (Application);
  newElementForm.SetInterface (cfDreamJournal);
  if (newElementForm.ShowModal = mrOk) then
  begin
    parentNode := FSelectedTreeNode.Data;
    xmlNode := TXMLNode.Create;
    xmlNode.TagName := TAG_FILE;
    xmlNode.TagType := ttShorted;
    xmlNode.SetAttributeValue (ATTRIBUTE_NAME, newElementForm.edt_First.Text);
    xmlNode.SetAttributeValue (ATTRIBUTE_PATH, newElementForm.edt_Second.Text);
    parentNode.AddChildAsObject (xmlNode);
    xmlNode.Level := parentNode.Level + 1;
    newXMLParser := TXMLParser.Create;
    newXMLParser.XMLParameters.XMLEncoding := XML_ENCODING;
    newXMLParser.XMLParameters.XMLStyleSheet := DREAM_JOURNAL_STYLESHEET;
    newXMLParser.XMLParameters.XMLDocType.DocTypeDefinition := DREAM_JOURNAL_DOCTYPE;
    newXMLParser.XMLRoot.TagName := TAG_DREAMJOURNAL;
    newXMLParser.SaveFile (newElementForm.edt_Second.Text);
    FHashTable.AddXMLParser (newXMLParser);
    FXMLPairList.AddPair (xmlNode, newXMLParser.XMLRoot);
    newTreeNode := tre_Directory.Items.AddChild (FSelectedTreeNode, newElementForm.edt_First.Text);
    newTreeNode.ImageIndex := 3;
    newTreeNode.Data := newXMLParser.XMLRoot;
    FSelectedTreeNode.Expand (False);
    newTreeNode.Selected := True;
  end;
  newElementForm.Free;
end;

procedure Tfrm_MainForm.btn_Tool_03Click (Sender : TObject);
var
  newElementForm : Tfrm_NewElement;
  xmlNode        : TXMLNode;
  parentNode     : TXMLNode;
  newTreeNode    : TTreeNode;
begin
  newElementForm := Tfrm_NewElement.Create (Application);
  newElementForm.SetInterface (cfOneNight);
  if (newElementForm.ShowModal = mrOk) then
  begin
    parentNode := FSelectedTreeNode.Data;
    xmlNode := TXMLNode.Create;
    xmlNode.TagName := TAG_DAY;
    xmlNode.SetAttributeValue (ATTRIBUTE_NAME, newElementForm.edt_First.Text);
    parentNode.AddChildAsObject (xmlNode);
    xmlNode.Level := parentNode.Level + 1;
    newTreeNode := tre_Directory.Items.AddChild (FSelectedTreeNode, newElementForm.edt_First.Text);
    newTreeNode.ImageIndex := 4;
    newTreeNode.Data := xmlNode;
    FSelectedTreeNode.Expand (False);
    newTreeNode.Selected := True;
  end;
  newElementForm.Free;
end;

procedure Tfrm_MainForm.btn_Tool_04Click (Sender : TObject);
var
  newElementForm : Tfrm_NewElement;
  xmlNode        : TXMLNode;
  parentNode     : TXMLNode;
  newTreeNode    : TTreeNode;
begin
  newElementForm := Tfrm_NewElement.Create (Application);
  newElementForm.NextNumber := FNextExperienceNumber;
  newElementForm.SetInterface (cfOneDream);
  newElementForm.ItemIndex := FExperienceView;
  if (newElementForm.ShowModal = mrOk) then
  begin
    ExperienceView := newElementForm.ItemIndex;
    parentNode := FSelectedTreeNode.Data;
    xmlNode := TXMLNode.Create;
    xmlNode.TagName := TAG_EXPERIENCE;
    xmlNode.SetAttributeValue (ATTRIBUTE_NUMBER, newElementForm.edt_First.Text);
    xmlNode.SetAttributeValue (ATTRIBUTE_TITLE, newElementForm.edt_Second.Text);
    if (newElementForm.rdg_DreamOption.ItemIndex = 1) then
    begin
      xmlNode.SetAttributeValue (ATTRIBUTE_TYPE, HTML_VALUE);
      xmlNode.SetAttributeValue (ATTRIBUTE_FILE, GetNewHTMLFileName (newElementForm.edt_First.Text));
    end;
    parentNode.AddChildAsObject (xmlNode);
    xmlNode.Level := parentNode.Level + 1;
    newTreeNode := tre_Directory.Items.AddChild (FSelectedTreeNode, newElementForm.edt_First.Text + NAME_DELIMITER + newElementForm.edt_Second.Text);
    newTreeNode.ImageIndex := 5;
    newTreeNode.Data := xmlNode;
    FSelectedTreeNode.Expand (False);
    newTreeNode.Selected := True;
  end;
  newElementForm.Free;
end;

procedure Tfrm_MainForm.trb_EnergyChange (Sender : TObject);
var
  sourceNode : TXMLNode;
  energyNode : TXMLNode;
begin
  sourceNode := FSelectedTreeNode.Data;
  energyNode := sourceNode.FindTagByName (TAG_ENERGY);
  if (energyNode = nil) then
  begin
    energyNode := TXMLNode.Create;
    energyNode.TagName := TAG_ENERGY;
    energyNode.TagType := ttShorted;
    sourceNode.AddChildAsObject (energyNode);
    energyNode.Level := sourceNode.Level + 1;
  end;
  energyNode.SetAttributeValue (ATTRIBUTE_LEVEL, IntToStr (trb_Energy.Position));

  if (trb_Energy.Position < trb_Energy.Min + trb_Energy.PageSize) then
  begin
    lbl_HighEnergyLevel.Font.Color := clRed;
    lbl_ZeroEnergyLevel.Font.Color := clBlack;
    lbl_LowEnergyLevel.Font.Color := clBlack;
    Exit;
  end;
  if ((trb_Energy.Position > (trb_Energy.Max - trb_Energy.PageSize) div 2) and (trb_Energy.Position < (trb_Energy.Max + trb_Energy.PageSize) div 2)) then
  begin
    lbl_HighEnergyLevel.Font.Color := clBlack;
    lbl_ZeroEnergyLevel.Font.Color := clRed;
    lbl_LowEnergyLevel.Font.Color := clBlack;
    Exit;
  end;
  if (trb_Energy.Position > trb_Energy.Max - trb_Energy.PageSize) then
  begin
    lbl_HighEnergyLevel.Font.Color := clBlack;
    lbl_ZeroEnergyLevel.Font.Color := clBlack;
    lbl_LowEnergyLevel.Font.Color := clRed;
    Exit;
  end;
  lbl_HighEnergyLevel.Font.Color := clBlack;
  lbl_ZeroEnergyLevel.Font.Color := clBlack;
  lbl_LowEnergyLevel.Font.Color := clBlack;
end;

procedure Tfrm_MainForm.lbl_HighEnergyLevelDblClick (Sender : TObject);
begin
  trb_Energy.Position := 0;
end;

procedure Tfrm_MainForm.lbl_ZeroEnergyLevelDblClick (Sender : TObject);
begin
  trb_Energy.Position := trb_Energy.Max div 2;
end;

procedure Tfrm_MainForm.lbl_LowEnergyLevelDblClick (Sender : TObject);
begin
  trb_Energy.Position := trb_Energy.Max;
end;

procedure Tfrm_MainForm.FormResize (Sender : TObject);
var
  tagName  : String;
  tempNode : TXMLnode;
begin
  lbl_ZeroEnergyLevel.Top := trb_Energy.Top + (trb_Energy.Height - lbl_ZeroEnergyLevel.Height) div 2;
  lbl_ZeroEnergyLevel.Left := trb_Energy.Left + 28;
  bvl_Border.Width := pnl_WorkArea.Width - 6;

  if (FSelectedTreeNode <> nil) then
  begin
    tempNode := FSelectedTreeNode.Data;
    tagName := tempNode.TagName;
    if ((tagName = TAG_DREAMJOURNAL) or (tagName = TAG_FILE)) then
    begin
      iFillBox (img_Graphs, 0, 0, img_Graphs.Width, img_Graphs.Height, clBtnFace, clBtnFace);
      PaintMonthGraph_1;
      PaintMonthGraph_2;
      Exit;
    end;
    if (tagName = TAG_DAY) then
    begin
      iFillBox (img_Graphs, 0, 0, img_Graphs.Width, img_Graphs.Height, clBtnFace, clBtnFace);
      PaintDayGraph_1;
      Exit;
    end;
    if (tagName = TAG_DIRECTORY) then
    begin
      iFillBox (img_Graphs, 0, 0, img_Graphs.Width, img_Graphs.Height, clBtnFace, clBtnFace);
      PaintYearGraph_1;
      PaintYearGraph_2;
      PaintYearGraph_3;
      Exit;
    end;
  end;
end;

procedure Tfrm_MainForm.CountNumberOfDreams (journalNode : TXMLNode);
begin
  { DONE 1 -cMethod -oDark Magus :  ,     TAG_EXPERIENCE   . }
  FNextExperienceNumber := GetNumberOfDreams (journalNode) + 1;
end;

function Tfrm_MainForm.GetNumberOfDreams (xmlNode : TXMLNode) : Integer;
var
  i         : Integer;
  counter   : Integer;
  childNode : TXMLNode;
begin
  counter := 0;
  for i := 0 to xmlNode.GetNumberOfChildren - 1 do
  begin
    childNode := xmlNode.GetChild (i);
    if (childNode.TagName = TAG_EXPERIENCE) then
    begin
      counter := counter + 1;
    end
    else
    begin
      counter := counter + GetNumberOfDreams (childNode);
    end;
  end;
  Result := counter;
end;

procedure Tfrm_MainForm.btn_AuthorizationClick (Sender : TObject);
var
  codec             : TCodec;
  authorizationForm : Tfrm_Authorization;
begin
  authorizationForm := Tfrm_Authorization.Create (Application);
  authorizationForm.SetInterface (afSetParameters);
  if (authorizationForm.ShowModal = mrOk) then
  begin
    if ((authorizationForm.edt_First.Text <> '') and (authorizationForm.edt_Second.Text <> '')) then
    begin
      codec := TCodec.Create;
      FLibraryFile.XMLRoot.SetAttributeValue (ATTRIBUTE_USER_NAME, codec.Encode (authorizationForm.edt_First.Text));
      FLibraryFile.XMLRoot.SetAttributeValue (ATTRIBUTE_USER_PASSWORD, codec.Encode (authorizationForm.edt_Second.Text));
      codec.Free;
    end
    else
    begin
      FLibraryFile.XMLRoot.DeleteAttribute (ATTRIBUTE_USER_NAME);
      FLibraryFile.XMLRoot.DeleteAttribute (ATTRIBUTE_USER_PASSWORD);
    end;
  end;
  authorizationForm.Free;
end;

{ DONE 2 -cMethod -oDark Magus :         XML.     . }
procedure Tfrm_MainForm.btn_MoveUpClick (Sender : TObject);
var
  selectedIndex   : Integer;
  expanded        : Boolean;
  selectedXMLNode : TXMLNode;
  parentXMLNode   : TXMLNode;
begin
  expanded := FSelectedTreeNode.Expanded;
  selectedXMLNode := FSelectedTreeNode.Data;
  parentXMLNode := FSelectedTreENode.Parent.Data;

  if (selectedXMLNode.TagName = TAG_DREAMJOURNAL) then
  begin
    selectedXMLNode := FXMLPairList.FindFileByJournal (selectedXMLNode);
  end;
  selectedIndex := parentXMLNode.GetChildNumber (selectedXMLNode);
  parentXMLNode.Children.Exchange (selectedIndex, selectedIndex - 1);

  FSelectedTreeNode.MoveTo (FSelectedTreeNode.Parent.GetPrevChild (FSelectedTreeNode), naInsert);
  if (FSelectedTreeNode = FSelectedTreeNode.Parent.GetFirstChild) then
  begin
    btn_MoveUp.Enabled := False;
  end;
  btn_MoveDown.Enabled := True;
  FSelectedTreeNode.Expanded := expanded;
end;

procedure Tfrm_MainForm.btn_MoveDownClick (Sender : TObject);
var
  selectedIndex    : Integer;
  expanded         : Boolean;
  selectedXMLNode  : TXMLNode;
  parentXMLNode    : TXMLNode;
  exchangeTreeNode : TTreeNode;
begin
  expanded := FSelectedTreeNode.Expanded;
  selectedXMLNode := FSelectedTreeNode.Data;
  parentXMLNode := FSelectedTreENode.Parent.Data;

  if (selectedXMLNode.TagName = TAG_DREAMJOURNAL) then
  begin
    selectedXMLNode := FXMLPairList.FindFileByJournal (selectedXMLNode);
  end;
  selectedIndex := parentXMLNode.GetChildNumber (selectedXMLNode);
  parentXMLNode.Children.Exchange (selectedIndex, selectedIndex + 1);

  exchangeTreeNode := FSelectedTreeNode.Parent.GetNextChild (FSelectedTreeNode);
  if (exchangeTreeNode = exchangeTreeNode.Parent.GetLastChild) then
  begin
    FSelectedTreeNode.MoveTo (FSelectedTreeNode.Parent, naAddChild);
  end
  else
  begin
    FSelectedTreeNode.MoveTo (FSelectedTreeNode.Parent.GetNextChild (exchangeTreeNode), naInsert);
  end;

  if (FSelectedTreeNode = FSelectedTreeNode.Parent.GetLastChild) then
  begin
    btn_MoveDown.Enabled := False;
  end;
  btn_MoveUp.Enabled := True;
  FSelectedTreeNode.Expanded := expanded;
end;

{ DONE 2 -cMethod -oDark Magus :           XML. ,    XML   . }
procedure Tfrm_MainForm.btn_DeleteClick (Sender : TObject);
var
  selectedXMLNode  : TXMLNode;
  parentXMLNode    : TXMLNode;
  optionsXMLNode   : TXMLNode;
  confirmationForm : Tfrm_Confirmation;
begin
  selectedXMLNode := FSelectedTreeNode.Data;
  parentXMLNode := FSelectedTreeNode.Parent.Data;

  if (FConfirmDelete) then
  begin
    confirmationForm := Tfrm_Confirmation.Create (Application);
    confirmationForm.lbl_Confirmation.Caption := QUESTION_DELETE_PART_1 + FSelectedTreeNode.Text + QUESTION_DELETE_PART_2;
    if (confirmationForm.ShowModal <> mrOk) then
    begin
      confirmationForm.Free;
      Exit;
    end;
    optionsXMLNode := FINIFile.FindTagByName (TAG_OPTIONS);
    if (optionsXMLNode = nil) then
    begin
      optionsXMLNode := TXMLNode.Create;
      optionsXMLNode.TagName := TAG_OPTIONS;
      optionsXMLNode.TagType := ttShorted;
      FINIFile.XMLRoot.AddChildAsObject (optionsXMLNode);
      optionsXMLNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
    if (confirmationForm.box_ShowAgain.Checked) then
    begin
      optionsXMLNode.SetAttributeValue (ATTRIBUTE_CONFIRMDELETE, STR_NO);
      FConfirmDelete := False;
    end
    else
    begin
      optionsXMLNode.SetAttributeValue (ATTRIBUTE_CONFIRMDELETE, STR_YES);
      FConfirmDelete := True;
    end;
    confirmationForm.Free;
  end;

  if (selectedXMLNode.TagName = TAG_DREAMJOURNAL) then
  begin
    selectedXMLNode := FXMLPairList.FindFileByJournal (selectedXMLNode);
  end;
  parentXMLNode.DeleteChild (parentXMLNode.GetChildNumber (selectedXMLNode));
  FSelectedTreeNode.Delete;
end;

procedure Tfrm_MainForm.DrawDirectoryGraph (treeNode : TTreeNode; iType : TYearStatistic);
var
  i             : Integer;
  nofPoints     : Integer;
  x             : Double;
  y             : Double;
  maxY          : Double;
  tempString    : String;
  pointName     : String;
  directoryNode : TXMLNode;
  statisticNode : TXMLNode;
  graphNode     : TXMLNode;
  pointNode     : TXMLNode;
  graph         : TDJGraph;
begin
  graphNode := nil;
  graph := nil;
  
  case (iType) of
    ysWholeQuantity:
      begin
        graph := FGraphPainter_1;
      end;
    ysAverageValue:
      begin
        graph := FGraphPainter_2;
      end;
    ysFirstFlagOn:
      begin
        graph := FGraphPainter_3;
      end;
  end;

  directoryNode := FSelectedTreeNode.Data;
  statisticNode := directoryNode.FindTagByName (TAG_STATISTIC);
  if (statisticNode <> nil) then
  begin
    case (iType) of
      ysWholeQuantity:
        begin
          graphNode := statisticNode.GetChild (0);
        end;
      ysAverageValue:
        begin
          graphNode := statisticNode.GetChild (1);
        end;
      ysFirstFlagOn:
        begin
          graphNode := statisticNode.GetChild (2);
        end;
    end;
    tempString := graphNode.GetAttributeValue (ATTRIBUTE_HEADER);

    if (tempString <> UNDEFINED_VALUE) then
    begin
      graph.Header.Caption := tempString;
    end
    else
    begin
      graph.Header.Caption := '';
    end;

    tempString := graphNode.GetAttributeValue (ATTRIBUTE_FOOTER);
    if (tempString <> UNDEFINED_VALUE) then
    begin
      graph.Footer.Caption := tempString;
    end
    else
    begin
      graph.Footer.Caption := '';
    end;

    maxY := 0;
    nofPoints := graphNode.GetNumberOfChildren;
    graph.ClearValues;
    for i := 0 to nofPoints - 1 do
    begin
      pointNode := graphNode.GetChild (i);
      pointName := pointNode.GetAttributeValue (ATTRIBUTE_NAME);
      x := StrToFloat (pointNode.GetAttributeValue (ATTRIBUTE_LEFT));
      y := StrToFloat (pointNode.GetAttributeValue (ATTRIBUTE_TOP));
      if (maxY < y) then
      begin
        maxY := y;
      end;
      graph.AddValue (pointName, x, y);
    end;

    graph.MinX := 0;
    graph.MaxX := nofPoints + 1;
    graph.MinY := 0;
    graph.MaxY := maxY;
    graph.XLabelsFrom   := 1;
    graph.XLabelsStep   := 1;
    graph.XLabelsCount  := nofPoints;
    graph.XLabelsFormat := '%.0n';
    graph.YLabelsFrom   := 0;
    if (iType = ysWholeQuantity) then
    begin
      graph.YLabelsStep   := 10;
    end
    else
    begin
      graph.YLabelsStep   := 1;
    end;
    graph.YLabelsCount  := -1;
    graph.YLabelsFormat := '%.0n';
    graph.GType := gtLinearRDot;

    case (iType) of
      ysWholeQuantity:
        begin
          PaintYearGraph_1;
        end;
      ysAverageValue:
        begin
          PaintYearGraph_2;
        end;
      ysFirstFlagOn:
        begin
          PaintYearGraph_3;
        end;
    end;

  end;
end;

procedure Tfrm_MainForm.DrawDirectoryGraphs (treeNode : TTreeNode);
var
  i             : Integer;
  j             : Integer;
  nofPoints     : Integer;
  x             : Double;
  y             : Double;
  maxY          : Double;
  maxCount      : Integer;
  tempString    : String;
  pointName     : String;
  directoryNode : TXMLNode;
  statisticNode : TXMLNode;
  graphNode     : TXMLNode;
  pointNode     : TXMLNode;
  graphs        : array[0..2] of TDJGraph;
begin
  iFillBox (img_Graphs, 0, 0, img_Graphs.Width, img_Graphs.Height, clBtnFace, clBtnFace);

  graphs[0] := FGraphPainter_1;
  graphs[1] := FGraphPainter_2;
  graphs[2] := FGraphPainter_3;
  directoryNode := FSelectedTreeNode.Data;
  statisticNode := directoryNode.FindTagByName (TAG_STATISTIC);
  if (statisticNode <> nil) then
  begin
    maxCount := statisticNode.GetNumberOfChildren;
    if (maxCount > 3) then
    begin
      maxCount := 3;
    end;
    for i := 0 to maxCount - 1 do
    begin
      graphNode := statisticNode.GetChild (i);
      tempString := graphNode.GetAttributeValue (ATTRIBUTE_HEADER);

      if (tempString <> UNDEFINED_VALUE) then
      begin
        graphs[i].Header.Caption := tempString;
      end
      else
      begin
        graphs[i].Header.Caption := '';
      end;

      tempString := graphNode.GetAttributeValue (ATTRIBUTE_FOOTER);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        graphs[i].Footer.Caption := tempString;
      end
      else
      begin
        graphs[i].Footer.Caption := '';
      end;

      maxY := 0;
      nofPoints := graphNode.GetNumberOfChildren;
      graphs[i].ClearValues;
      for j := 0 to nofPoints - 1 do
      begin
        pointNode := graphNode.GetChild (j);
        pointName := pointNode.GetAttributeValue (ATTRIBUTE_NAME);
        x := StrToFloat (pointNode.GetAttributeValue (ATTRIBUTE_LEFT));
        y := StrToFloat (pointNode.GetAttributeValue (ATTRIBUTE_TOP));
        if (maxY < y) then
        begin
          maxY := y;
        end;
        graphs[i].AddValue (pointName, x, y);
      end;

      graphs[i].MinX := 0;
      graphs[i].MaxX := nofPoints + 1;
      graphs[i].MinY := 0;
      graphs[i].MaxY := maxY;
      graphs[i].XLabelsFrom   := 1;
      graphs[i].XLabelsStep   := 1;
      graphs[i].XLabelsCount  := nofPoints;
      graphs[i].XLabelsFormat := '%.0n';
      graphs[i].YLabelsFrom   := 0;
      if (i = 0) then
      begin
        graphs[i].YLabelsStep   := 10;
      end
      else
      begin
        graphs[i].YLabelsStep   := 1;
      end;
      graphs[i].YLabelsCount  := -1;
      graphs[i].YLabelsFormat := '%.0n';
      graphs[i].GType := gtLinearRDot;

    end;

    PaintYearGraph_1;
    PaintYearGraph_2;
    PaintYearGraph_3;

  end
  else
  begin
    { DONE 2 -cMethod -oDark Magus :   ,     INI-  STATISTIC   ,    . }
    statisticNode := TXMLNode.Create;
    statisticNode.TagName := TAG_STATISTIC;
    directoryNode.AddChildAsObject (statisticNode);
    statisticNode.Level := directoryNode.Level + 1;

    CollectYearStatistic (ysWholeQuantity, statisticNode);
    CollectYearStatistic (ysAverageValue, statisticNode);
    CollectYearStatistic (ysFirstFlagOn, statisticNode);

    DrawDirectoryGraphs (treeNode);
  end;
end;

procedure Tfrm_MainForm.DrawDayGraphs (treeNode : TTreeNode);
var
  i              : Integer;
  index          : Integer;
  nofExperiences : Integer;
  badChildren    : Integer;
  averageLevel   : Double;
  summ           : Double;
  energyLevel    : Double;
  tempString     : String;
  experienceNode : TXMLNode;
  energyNode     : TXMLNode;
  childNode      : TXMLNode;
begin
  experienceNode := FSelectedTreeNode.Data;
  nofExperiences := experienceNode.GetNumberOfChildren;
  badChildren := 0;
  summ := 0.0;
  averageLevel := 0.0;

  with (FGraphPainter_1) do
  begin
    ClearValues;

    index := 1;
    for i := 0 to nofExperiences - 1 do
    begin
      childNode := experienceNode.GetChild (i);
      if (childNode.TagName = TAG_EXPERIENCE) then
      begin
        energyNode := childNode.FindTagByName (TAG_ENERGY);
        if (energyNode = nil) then
        begin
          AddValue ('', index, 0);
        end
        else
        begin
          tempString := energyNode.GetAttributeValue (ATTRIBUTE_LEVEL);
          energyLevel := ((trb_Energy.Max div 2) - (StrToInt (tempString))) / (trb_Energy.Max div 2);
          summ := summ + energyLevel;
          AddValue ('', index, energyLevel);
        end;
        index := index + 1;
      end
      else
      begin
        badChildren := badChildren + 1;
      end;
    end;
    nofExperiences := nofExperiences - badChildren;
    if (nofExperiences <> 0) then
    begin
      averageLevel := summ / nofExperiences;
    end;

    MinX := 0;
    MaxX := nofExperiences + 1;
    MinY := -1;
    MaxY := 1;
    XLabelsFrom   := 1;
    XLabelsStep   := 1;
    XLabelsCount  := nofExperiences;
    XLabelsFormat := '%.0n';
    YLabelsFrom   := -1;
    YLabelsStep   := 0.25;
    YLabelsCount  := -1;
    YLabelsFormat := '%.2n';

    Header.Caption := GRAPH_HEADER_DAY_1;
    Footer.Caption := GRAPH_FOOTER_DAY_1 + FloatToStr (averageLevel);

    GType := gtLinearRDot;
  end;

  iFillBox (img_Graphs, 0, 0, img_Graphs.Width, img_Graphs.Height, clBtnFace, clBtnFace);
  PaintDayGraph_1;
end;

procedure Tfrm_MainForm.DrawJournalGraphs (treeNode : TTreeNode);
var
  i              : Integer;
  j              : Integer;
  nofItems       : Integer;
  nofExperiences : Integer;
  label_1_Count  : Integer;
  label_2_Count  : Integer;
  label_3_Count  : Integer;
  label_4_Count  : Integer;
  tempTreeNode   : TTreeNode;
  experienceNode : TXMLNode;
  propertyNode   : TXMLNode;
begin
  nofExperiences := 0;
  nofItems := treeNode.Count;

  with (FGraphPainter_1) do
  begin
    MinX := 0;
    MaxX := nofItems + 1;
    MinY := 0;
    MaxY := 1;

    for i := 0 to treeNode.Count - 1 do
    begin
      tempTreeNode := treeNode.Item[i];
      if (MaxY < tempTreeNode.Count) then
      begin
        MaxY := tempTreeNode.Count;
      end;
      nofExperiences := nofExperiences + tempTreeNode.Count;
    end;

    XLabelsFrom   := 1;
    XLabelsStep   := 1;
    XLabelsCount  := nofItems;
    XLabelsFormat := '%.0n';
    YLabelsFrom   := 0;
    YLabelsStep   := 1;
    YLabelsCount  := -1;
    YLabelsFormat := '%.0n';

    ClearValues;
    for i := 0 to nofItems - 1 do
    begin
      tempTreeNode := treeNode.Item[i];
      AddValue ('', i + 1, tempTreeNode.Count);
    end;

    Header.Caption := GRAPH_HEADER_MONTH_1;
    Footer.Caption := '';

    GType := gtLinearRDot;

  end;

  label_1_Count := 0;
  label_2_Count := 0;
  label_3_Count := 0;
  label_4_Count := 0;
  with (FGraphPainter_2) do
  begin
    MinX := 1;
    if (box_Label1.Tag = 1) then MaxX := 1;
    if (box_Label2.Tag = 1) then MaxX := 2;
    if (box_Label3.Tag = 1) then MaxX := 3;
    if (box_Label4.Tag = 1) then MaxX := 4;
    MinY := 0;
    MaxY := 0;

    for i := 0 to treeNode.Count - 1 do
    begin
      tempTreeNode := treeNode.Item[i];
      for j := 0 to tempTreeNode.Count - 1 do
      begin
        experienceNode := (tempTreeNode.Item[j] as TTreeNode).Data;
        propertyNode := experienceNode.FindTagByName (TAG_PROPERTIES);
        if (propertyNode <> nil) then
        begin
          if (propertyNode.GetAttributeValue (ATTRIBUTE_LABEL1) = TRUE_VALUE) then label_1_Count := label_1_Count + 1;
          if (propertyNode.GetAttributeValue (ATTRIBUTE_LABEL2) = TRUE_VALUE) then label_2_Count := label_2_Count + 1;
          if (propertyNode.GetAttributeValue (ATTRIBUTE_LABEL3) = TRUE_VALUE) then label_3_Count := label_3_Count + 1;
          if (propertyNode.GetAttributeValue (ATTRIBUTE_LABEL4) = TRUE_VALUE) then label_4_Count := label_4_Count + 1;
        end;
      end;
    end;

    MaxY := label_1_Count;
    if (MaxY < label_2_Count) then MaxY := label_2_Count;
    if (MaxY < label_3_Count) then MaxY := label_3_Count;
    if (MaxY < label_4_Count) then MaxY := label_4_Count;

    XLabelsFrom   := 1;
    XLabelsStep   := 1;
    XLabelsCount  := -1;
    XLabelsFormat := '%.0n';
    YLabelsFrom   := 0;
    YLabelsStep   := 1;
    YLabelsCount  := -1;
    YLabelsFormat := '%.0n';

    ClearValues;
    if (box_Label1.Tag = 1) then AddValue (box_Label1.Caption, 1, label_1_Count);
    if (box_Label2.Tag = 1) then AddValue (box_Label1.Caption, 2, label_2_Count);
    if (box_Label3.Tag = 1) then AddValue (box_Label1.Caption, 3, label_3_Count);
    if (box_Label4.Tag = 1) then AddValue (box_Label1.Caption, 4, label_4_Count);

    Header.Caption := GRAPH_HEADER_MONTH_2;
    Footer.Caption := GRAPH_FOOTER_MONTH_2 + IntToStr (nofExperiences);

    GType := gtHHistogram;

  end;

  iFillBox (img_Graphs, 0, 0, img_Graphs.Width, img_Graphs.Height, clBtnFace, clBtnFace);
  PaintMonthGraph_1;
  PaintMonthGraph_2;
end;

procedure Tfrm_MainForm.SetEditorText (s : String);
begin
  mmo_Description.Text := s;
end;

function Tfrm_MainForm.GetEditorText : String;
begin
  Result := mmo_Description.Text;
end;

procedure Tfrm_MainForm.tre_DirectoryChanging (Sender : TObject; Node : TTreeNode; var AllowChange : Boolean);
var
  i            : Integer;
  tempString   : String;
  childNode    : TXMLNode;
  xmlNode      : TXMLNode;
  xmlParser    : TXMLParser;
begin
  if (not FTag) then
  begin

    if (FSelectedTreeNode <> nil) then
    begin
      xmlNode := FSelectedTreeNode.Data;
      if (xmlNode.GetAttributeValue (ATTRIBUTE_TYPE) = HTML_VALUE) then
      begin
        btn_HTML_SaveClick (nil);
      end;
    end;

    FSelectedTreeNode := Node;
    { DONE 2 -cMethod -oDark Magus :          . }
    xmlNode := Node.Data;
    if (xmlNode.TagName = TAG_DREAMLIBRARY) then
    begin
      FillIn (cfDreamLibrary, xmlNode);
      SetVisibilityOfControls (cfDreamLibrary);
      btn_ViewInBrowser.Enabled := True;
      mnu_ViewAsHTML.Enabled := False;
      mnu_RefreshAll.Enabled := False;
      mnu_ViewAsHTML.Enabled := True;
      mnu_RefreshAll.Enabled := False;
      mnu_View.Enabled := True;
      mnu_Export.Enabled := True;
      mnu_CreateCatalogue.Enabled := True;
      mnu_CreateCatalogue_1.Enabled := True;
      mnu_CreateJournal.Enabled := False;
      mnu_CreateJournal_1.Enabled := False;
      mnu_CreateNight.Enabled := False;
      mnu_CreateNight_1.Enabled := False;
      mnu_CreateExperience.Enabled := False;
      mnu_CreateExperience_1.Enabled := False;
      btn_MoveUp.Enabled := False;
      mnu_MoveUp.Enabled := False;
      btn_MoveDown.Enabled := False;
      mnu_MoveDown.Enabled := False;
      btn_Delete.Enabled := False;
      mnu_Delete.Enabled := False;
      Exit;
    end;

    btn_Delete.Enabled := True;
    mnu_Delete.Enabled := True;
    if (Node = Node.Parent.GetFirstChild) then
    begin
      btn_MoveUp.Enabled := False;
      mnu_MoveUp.Enabled := False;
    end
    else
    begin
      btn_MoveUp.Enabled := True;
      mnu_MoveUp.Enabled := True;
    end;
    if (Node = Node.Parent.GetLastChild) then
    begin
      btn_MoveDown.Enabled := False;
      mnu_MoveDown.Enabled := False;
    end
    else
    begin
      btn_MoveDown.Enabled := True;
      mnu_MoveDown.Enabled := True;
    end;

    if (xmlNode.TagName = TAG_DIRECTORY) then
    begin
      FillIn (cfDirectory, xmlNode);
      SetVisibilityOfControls (cfDirectory);
      btn_ViewInBrowser.Enabled := False;
      mnu_ViewAsHTML.Enabled := False;
      mnu_RefreshAll.Enabled := True;
      mnu_View.Enabled := True;
      mnu_Export.Enabled := False;
      mnu_CreateCatalogue.Enabled := True;
      mnu_CreateCatalogue_1.Enabled := True;
      mnu_CreateJournal.Enabled := True;
      mnu_CreateJournal_1.Enabled := True;
      mnu_CreateNight.Enabled := False;
      mnu_CreateNight_1.Enabled := False;
      mnu_CreateExperience.Enabled := False;
      mnu_CreateExperience_1.Enabled := False;

      DrawDirectoryGraphs (Node);

      Exit;
    end;

    if (xmlNode.TagName = TAG_FILE) then
    begin
      FillIn (cfDreamJournal, xmlNode);
      SetVisibilityOfControls (cfDreamJournal);
      btn_ViewInBrowser.Enabled := True;
      mnu_ViewAsHTML.Enabled := True;
      mnu_RefreshAll.Enabled := True;
      mnu_View.Enabled := True;
      mnu_Export.Enabled := True;
      mnu_CreateCatalogue.Enabled := False;
      mnu_CreateCatalogue_1.Enabled := False;
      mnu_CreateJournal.Enabled := False;
      mnu_CreateJournal_1.Enabled := False;
      mnu_CreateNight.Enabled := True;
      mnu_CreateNight_1.Enabled := True;
      mnu_CreateExperience.Enabled := False;
      mnu_CreateExperience_1.Enabled := False;
      tempString := xmlNode.GetAttributeValue (ATTRIBUTE_PATH);
      if (tempString <> UNDEFINED_VALUE) then
      begin
        xmlParser := FHashTable.GetXMLParser (tempString);
        for i := 0 to xmlParser.XMLRoot.GetNumberOfChildren - 1 do
        begin
          childNode := xmlParser.XMLRoot.GetChild (i);
          ConvertXMLNodeToTreeNode (Node, childNode);
        end;
        Node.Data := xmlParser.XMLRoot;
        FXMLPairList.AddOneInstance (xmlNode, xmlParser.XMLRoot);
        if (FCurrentFileNode <> nil) then
        begin
          FCurrentFileNode.SetAttributeValue (ATTRIBUTE_DEFAULT, STR_NO);
        end;
        FCurrentFileNode := xmlNode;
        FCurrentFileNode.SetAttributeValue (ATTRIBUTE_DEFAULT, STR_YES);
        DrawJournalGraphs (Node);
      end;
      Exit;
    end;

    if (xmlNode.TagName = TAG_DREAMJOURNAL) then
    begin
      { DONE 3 -cMethod -oDark Magus :       ,     . }
      FillIn (cfDreamJournal, xmlNode);
      SetVisibilityOfControls (cfDreamJournal);
      btn_ViewInBrowser.Enabled := True;
      mnu_ViewAsHTML.Enabled := True;
      mnu_RefreshAll.Enabled := True;
      mnu_View.Enabled := True;
      mnu_Export.Enabled := True;
      mnu_CreateCatalogue.Enabled := False;
      mnu_CreateCatalogue_1.Enabled := False;
      mnu_CreateJournal.Enabled := False;
      mnu_CreateJournal_1.Enabled := False;
      mnu_CreateNight.Enabled := True;
      mnu_CreateNight_1.Enabled := True;
      mnu_CreateExperience.Enabled := False;
      mnu_CreateExperience_1.Enabled := False;

      if (FCurrentFileNode <> nil) then
      begin
        FCurrentFileNode.SetAttributeValue (ATTRIBUTE_DEFAULT, STR_NO);
      end;
      FCurrentFileNode := FXMLPairList.FindFileByJournal (xmlNode);
      FCurrentFileNode.SetAttributeValue (ATTRIBUTE_DEFAULT, STR_YES);

      { DONE 2 -cMethod -oDarkMagus :        . }
      DrawJournalGraphs (Node);

      Exit;
    end;

    if (xmlNode.TagName = TAG_DAY) then
    begin
      FillIn (cfOneNight, xmlNode);
      SetVisibilityOfControls (cfOneNight);
      btn_ViewInBrowser.Enabled := False;
      mnu_ViewAsHTML.Enabled := False;
      mnu_RefreshAll.Enabled := True;
      mnu_View.Enabled := True;
      mnu_Export.Enabled := False;
      mnu_CreateCatalogue.Enabled := False;
      mnu_CreateCatalogue_1.Enabled := False;
      mnu_CreateJournal.Enabled := False;
      mnu_CreateJournal_1.Enabled := False;
      mnu_CreateNight.Enabled := False;
      mnu_CreateNight_1.Enabled := False;
      mnu_CreateExperience.Enabled := True;
      mnu_CreateExperience_1.Enabled := True;
      CountNumberOfDreams (Node.Parent.Data);

      DrawDayGraphs (Node);

      Exit;
    end;

    if (xmlNode.TagName = TAG_EXPERIENCE) then
    begin
      if (xmlNode.GetAttributeValue (ATTRIBUTE_TYPE) = HTML_VALUE) then
      begin
        FillHTMLEditor (xmlNode);
        MakeReadyHTMLEditor;
      end
      else
      begin
        FillIn (cfOneDream, xmlNode);
        SetVisibilityOfControls (cfOneDream);
      end;
      if (xmlNode.GetAttributeValue (ATTRIBUTE_READONLY) = TRUE_VALUE) then
      begin
        MakeNodeReadOnly;
      end
      else
      begin
        MakeNodeWritable;
      end;
      btn_ViewInBrowser.Enabled := False;
      mnu_ViewAsHTML.Enabled := False;
      mnu_RefreshAll.Enabled := False;
      mnu_View.Enabled := False;
      mnu_Export.Enabled := False;
      mnu_CreateCatalogue.Enabled := False;
      mnu_CreateCatalogue_1.Enabled := False;
      mnu_CreateJournal.Enabled := False;
      mnu_CreateJournal_1.Enabled := False;
      mnu_CreateNight.Enabled := False;
      mnu_CreateNight_1.Enabled := False;
      mnu_CreateExperience.Enabled := False;
      mnu_CreateExperience_1.Enabled := False;
      Exit;
    end;
  end;
end;

procedure Tfrm_MainForm.PaintMonthGraph_1;
var
  x1 : Integer;
  y1 : Integer;
  x2 : Integer;
  y2 : Integer;
begin
  x1 := 10;
  y1 := bvl_Border.Top + 15;
  x2 := img_Graphs.Width - 10;
  y2 := (img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height)) div 2 + 25;
  img_Graphs.Picture.Bitmap.Width := img_Graphs.Width;
  img_Graphs.Picture.Bitmap.Height := img_Graphs.Height;
  iFillBox (img_Graphs, x1, y1, (x2 - x1), (y2 - y1), clBlack, clBtnFace);
  FGraphPainter_1.HistColWidth  := 7.5 / (x2 - x1);
  FGraphPainter_1.Paint (img_Graphs.Picture.Bitmap, Rect (x1 + 10, y1 + 5, x2 - 10, y2 - 5));
  btn_Copy_1.Left := x2 - btn_Copy_1.Width - 5;
  btn_Copy_1.Top := y1 + 5;
  btn_Copy_1.Visible := True;
  btn_Refresh_1.Left := x2 - btn_Refresh_1.Width - 5;
  btn_Refresh_1.Top := y1 + btn_Copy_1.Height + 6;
  btn_Refresh_1.Visible := True;
end;

procedure Tfrm_MainForm.PaintMonthGraph_2;
var
  x1 : Integer;
  y1 : Integer;
  x2 : Integer;
  y2 : Integer;
begin
  x1 := 10;
  y1 := (img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height)) div 2 + 35;
  x2 := img_Graphs.Width div 2 - 20;
  y2 := img_Graphs.Height - 10;
  img_Graphs.Picture.Bitmap.Width := img_Graphs.Width;
  img_Graphs.Picture.Bitmap.Height := img_Graphs.Height;
  iFillBox (img_Graphs, x1, y1, (x2 - x1), (y2 - y1), clBlack, clBtnFace);
  FGraphPainter_2.HistColWidth  := 0.1;
  FGraphPainter_2.Paint (img_Graphs.Picture.Bitmap, Rect (x1 + 10, y1 + 5, x2 - 10, y2 - 5));
  btn_Copy_2.Left := x2 - btn_Copy_2.Width - 5;
  btn_Copy_2.Top := y1 + 5;
  btn_Copy_2.Visible := True;
  btn_Refresh_2.Left := x2 - btn_Refresh_2.Width - 5;
  btn_Refresh_2.Top := y1 + btn_Copy_2.Height + 6;
  btn_Refresh_2.Visible := True;
end;

procedure Tfrm_MainForm.PaintDayGraph_1;
var
  x1 : Integer;
  y1 : Integer;
  x2 : Integer;
  y2 : Integer;
begin
  x1 := 10;
  y1 := bvl_Border.Top + 15;
  x2 := img_Graphs.Width - 10;
  y2 := (img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height)) div 2 + 25;
  img_Graphs.Picture.Bitmap.Width := img_Graphs.Width;
  img_Graphs.Picture.Bitmap.Height := img_Graphs.Height;
  iFillBox (img_Graphs, x1, y1, (x2 - x1), (y2 - y1), clBlack, clBtnFace);
  FGraphPainter_1.HistColWidth  := 7.5 / (x2 - x1);
  FGraphPainter_1.Paint (img_Graphs.Picture.Bitmap, Rect (x1 + 10, y1 + 5, x2 - 10, y2 - 5));
  btn_Copy_1.Left := x2 - btn_Copy_1.Width - 5;
  btn_Copy_1.Top := y1 + 5;
  btn_Copy_1.Visible := True;
  btn_Refresh_1.Left := x2 - btn_Refresh_1.Width - 5;
  btn_Refresh_1.Top := y1 + btn_Copy_1.Height + 6;
  btn_Refresh_1.Visible := True;
end;

procedure Tfrm_MainForm.InitializeGraphs;
begin
  FGraphPainter_1 := TDJGraph.Create;
  with (FGraphPainter_1) do
  begin
    with (LabelsFont) do
    begin
      Name    := 'Tahoma';
      Size    := 6;
      Color   := clBlack;
      Style   := [fsBold];
      Charset := RUSSIAN_CHARSET;
    end;

    with (Header.Font) do
    begin
      Name      := 'Tahoma';
      Size      := 8;
      Color     := clNavy;
      Style     := [fsBold];
      Charset   := RUSSIAN_CHARSET;
    end;
    Header.Alignment := taLeftJustify;

    with (Footer.Font) do
    begin
      Name      := 'Tahoma';
      Size      := 7;
      Color     := clNavy;
      Charset   := RUSSIAN_CHARSET;
    end;
    Footer.Alignment := taRightJustify;

    SetValuesColor ([clMaroon, clRed, clYellow, clWhite]);
    ValuesBorderColor := clNavy;
    AxisColor         := clBlack;
    BgColor           := clNone;
  end;

  FGraphPainter_2 := TDJGraph.Create;
  with (FGraphPainter_2) do
  begin
    with (LabelsFont) do
    begin
      Name    := 'Tahoma';
      Size    := 6;
      Color   := clBlack;
      Style   := [fsBold];
      Charset := RUSSIAN_CHARSET;
    end;

    with (Header.Font) do
    begin
      Name      := 'Tahoma';
      Size      := 8;
      Color     := clNavy;
      Style     := [fsBold];
      Charset   := RUSSIAN_CHARSET;
    end;
    Header.Alignment := taLeftJustify;

    with (Footer.Font) do
    begin
      Name      := 'Tahoma';
      Size      := 7;
      Color     := clNavy;
      Charset   := RUSSIAN_CHARSET;
    end;
    Footer.Alignment := taRightJustify;

    SetValuesColor ([clPurple, clNavy, clBlue, clAqua, clWhite]);
    ValuesBorderColor := clNavy;
    AxisColor         := clBlack;
    BgColor           := clNone;
  end;

  FGraphPainter_3 := TDJGraph.Create;
  with (FGraphPainter_3) do
  begin
    with (LabelsFont) do
    begin
      Name    := 'Tahoma';
      Size    := 6;
      Color   := clBlack;
      Style   := [fsBold];
      Charset := RUSSIAN_CHARSET;
    end;

    with (Header.Font) do
    begin
      Name      := 'Tahoma';
      Size      := 8;
      Color     := clNavy;
      Style     := [fsBold];
      Charset   := RUSSIAN_CHARSET;
    end;
    Header.Alignment := taLeftJustify;

    with (Footer.Font) do
    begin
      Name      := 'Tahoma';
      Size      := 7;
      Color     := clNavy;
      Charset   := RUSSIAN_CHARSET;
    end;
    Footer.Alignment := taRightJustify;

    SetValuesColor ([clOlive, clGreen, clLime, clWhite]);
    ValuesBorderColor := clNavy;
    AxisColor         := clBlack;
    BgColor           := clNone;
  end;

end;

procedure Tfrm_MainForm.btn_Refresh_1Click (Sender : TObject);
var
  i             : Integer;
  tagName       : String;
  tempNode      : TXMLNode;
  statisticNode : TXMLNode;
begin
  if (FSelectedTreeNode <> nil) then
  begin
    tempNode := FSelectedTreeNode.Data;
    tagName := tempNode.TagName;
    if ((tagName = TAG_DREAMJOURNAL) or (tagName = TAG_FILE)) then
    begin
      PaintMonthGraph_1;
      Exit;
    end;
    if (tagName = TAG_DAY) then
    begin
      PaintDayGraph_1;
      Exit;
    end;
    if (tagName = TAG_DIRECTORY) then
    begin
      for i := 0 to tempNode.GetNumberOfChildren - 1 do
      begin
        statisticNode := tempNode.GetChild (i);
        if (statisticNode.TagName = TAG_STATISTIC) then
        begin
          CollectYearStatistic (ysWholeQuantity, statisticNode);
          DrawDirectoryGraph (FSelectedTreeNode, ysWholeQuantity);
          Exit;
        end;
      end;
      statisticNode := TXMLNode.Create;
      statisticNode.TagName := TAG_STATISTIC;
      tempNode.AddChildAsObject (statisticNode);
      statisticNode.Level := tempNode.Level + 1;
      CollectYearStatistic (ysWholeQuantity, statisticNode);
      DrawDirectoryGraph (FSelectedTreeNode, ysWholeQuantity);
      Exit;
    end;
  end;
end;

procedure Tfrm_MainForm.btn_Refresh_2Click (Sender : TObject);
var
  i             : Integer;
  tagName       : String;
  tempNode      : TXMLNode;
  statisticNode : TXMLNode;
begin
  if (FSelectedTreeNode <> nil) then
  begin
    tempNode := FSelectedTreeNode.Data;
    tagName := tempNode.TagName;
    if ((tagName = TAG_DREAMJOURNAL) or (tagName = TAG_FILE)) then
    begin
      PaintMonthGraph_2;
      Exit;
    end;
    if (tagName = TAG_DIRECTORY) then
    begin
      for i := 0 to tempNode.GetNumberOfChildren - 1 do
      begin
        statisticNode := tempNode.GetChild (i);
        if (statisticNode.TagName = TAG_STATISTIC) then
        begin
          CollectYearStatistic (ysAverageValue, statisticNode);
          DrawDirectoryGraph (FSelectedTreeNode, ysAverageValue);
          Exit;
        end;
      end;
      statisticNode := TXMLNode.Create;
      statisticNode.TagName := TAG_STATISTIC;
      tempNode.AddChildAsObject (statisticNode);
      statisticNode.Level := tempNode.Level + 1;
      CollectYearStatistic (ysAverageValue, statisticNode);
      DrawDirectoryGraph (FSelectedTreeNode, ysAverageValue);
      Exit;
    end;
  end;
end;

procedure Tfrm_MainForm.btn_Refresh_3Click (Sender : TObject);
var
  i             : Integer;
  tagName       : String;
  tempNode      : TXMLNode;
  statisticNode : TXMLNode;
begin
  if (FSelectedTreeNode <> nil) then
  begin
    tempNode := FSelectedTreeNode.Data;
    tagName := tempNode.TagName;
    if (tagName = TAG_DIRECTORY) then
    begin
      for i := 0 to tempNode.GetNumberOfChildren - 1 do
      begin
        statisticNode := tempNode.GetChild (i);
        if (statisticNode.TagName = TAG_STATISTIC) then
        begin
          CollectYearStatistic (ysFirstFlagOn, statisticNode);
          DrawDirectoryGraph (FSelectedTreeNode, ysFirstFlagOn);
          Exit;
        end;
      end;
      statisticNode := TXMLNode.Create;
      statisticNode.TagName := TAG_STATISTIC;
      tempNode.AddChildAsObject (statisticNode);
      statisticNode.Level := tempNode.Level + 1;
      CollectYearStatistic (ysFirstFlagOn, statisticNode);
      DrawDirectoryGraph (FSelectedTreeNode, ysFirstFlagOn);
      Exit;
    end;
  end;
end;

procedure Tfrm_MainForm.SetExperienceView (iValue : Integer);
var
  optionsXMLNode : TXMLNode;
begin
  FExperienceView := iValue;

  optionsXMLNode := FINIFile.FindTagByName (TAG_OPTIONS);
  if (optionsXMLNode = nil) then
  begin
    optionsXMLNode := TXMLNode.Create;
    optionsXMLNode.TagName := TAG_OPTIONS;
    optionsXMLNode.TagType := ttShorted;
    FINIFile.XMLRoot.AddChildAsObject (optionsXMLNode);
    optionsXMLNode.Level := FINIFile.XMLRoot.Level + 1;
  end;

  case (FExperienceView) of
    0:
      begin
        optionsXMLNode.SetAttributeValue (ATTRIBUTE_EXPERIENCEVIEW, PLAINTEXT_VALUE);
      end;
    1:
      begin
        optionsXMLNode.SetAttributeValue (ATTRIBUTE_EXPERIENCEVIEW, HTML_VALUE);
      end;
  end;
end;

procedure Tfrm_MainForm.PaintYearGraph_1;
var
  x1 : Integer;
  y1 : Integer;
  x2 : Integer;
  y2 : Integer;
begin
  x1 := 10;
  y1 := bvl_Border.Top + 15;
  x2 := img_Graphs.Width - 10;
  y2 := y1 + ((img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height + 36)) div 3);
  img_Graphs.Picture.Bitmap.Width := img_Graphs.Width;
  img_Graphs.Picture.Bitmap.Height := img_Graphs.Height;
  iFillBox (img_Graphs, x1, y1, (x2 - x1), (y2 - y1), clBlack, clBtnFace);
  FGraphPainter_1.HistColWidth  := 7.5 / (x2 - x1);
  FGraphPainter_1.Paint (img_Graphs.Picture.Bitmap, Rect (x1 + 10, y1 + 5, x2 - 10, y2 - 5));
  btn_Copy_1.Left := x2 - btn_Copy_1.Width - 5;
  btn_Copy_1.Top := y1 + 5;
  btn_Copy_1.Visible := True;
  btn_Refresh_1.Left := x2 - btn_Refresh_1.Width - 5;
  btn_Refresh_1.Top := y1 + btn_Copy_1.Height + 6;
  btn_Refresh_1.Visible := True;
end;

procedure Tfrm_MainForm.PaintYearGraph_2;
var
  x1 : Integer;
  y1 : Integer;
  x2 : Integer;
  y2 : Integer;
begin
  x1 := 10;
  y1 := bvl_Border.Top + ((img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height + 36)) div 3) + 25;
  x2 := img_Graphs.Width - 10;
  y2 := y1 + ((img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height + 36)) div 3);
  img_Graphs.Picture.Bitmap.Width := img_Graphs.Width;
  img_Graphs.Picture.Bitmap.Height := img_Graphs.Height;
  iFillBox (img_Graphs, x1, y1, (x2 - x1), (y2 - y1), clBlack, clBtnFace);
  FGraphPainter_2.HistColWidth  := 7.5 / (x2 - x1);
  FGraphPainter_2.Paint (img_Graphs.Picture.Bitmap, Rect (x1 + 10, y1 + 5, x2 - 10, y2 - 5));
  btn_Copy_2.Left := x2 - btn_Copy_2.Width - 5;
  btn_Copy_2.Top := y1 + 5;
  btn_Copy_2.Visible := True;
  btn_Refresh_2.Left := x2 - btn_Refresh_2.Width - 5;
  btn_Refresh_2.Top := y1 + btn_Copy_2.Height + 6;
  btn_Refresh_2.Visible := True;
end;

procedure Tfrm_MainForm.PaintYearGraph_3;
var
  x1 : Integer;
  y1 : Integer;
  x2 : Integer;
  y2 : Integer;
begin
  x1 := 10;
  y1 := bvl_Border.Top + (((img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height + 36)) div 3) * 2) + 35;
  x2 := img_Graphs.Width - 10;
  y2 := y1 + ((img_Graphs.Height - (bvl_Border.Top + bvl_Border.Height + 36)) div 3);
  img_Graphs.Picture.Bitmap.Width := img_Graphs.Width;
  img_Graphs.Picture.Bitmap.Height := img_Graphs.Height;
  iFillBox (img_Graphs, x1, y1, (x2 - x1), (y2 - y1), clBlack, clBtnFace);
  FGraphPainter_3.HistColWidth  := 7.5 / (x2 - x1);
  FGraphPainter_3.Paint (img_Graphs.Picture.Bitmap, Rect (x1 + 10, y1 + 5, x2 - 10, y2 - 5));
  btn_Copy_3.Left := x2 - btn_Copy_3.Width - 5;
  btn_Copy_3.Top := y1 + 5;
  btn_Copy_3.Visible := True;
  btn_Refresh_3.Left := x2 - btn_Refresh_3.Width - 5;
  btn_Refresh_3.Top := y1 + btn_Copy_3.Height + 6;
  btn_Refresh_3.Visible := True;
end;

procedure Tfrm_MainForm.CollectYearStatistic (iType : TYearStatistic; var xmlNode : TXMLNode);
var
  i              : Integer;
  j              : Integer;
  k              : Integer;
  index          : Integer;
  nofExperiences : Integer;
  totalSumm      : Integer;
  grandTotalSumm : Integer;
  firstFlagOn    : Integer;
  totalFlagOn    : Integer;
  nofDays        : Integer;
  tempStr        : String;
  directoryNode  : TXMLNode;
  graphNode      : TXMLNode;
  pointNode      : TXMLNode;
  fileNode       : TXMLNode;
  journalNode    : TXMLNode;
  childNode      : TXMLNode;
  experienceNode : TXMLNode;
  dayNode        : TXMLNode;
  propertiesNode : TXMLNode;
  xmlParser      : TXMLParser;
  treeNode       : TTreeNode;

  procedure CreateGraphNode (var iGraphNode : TXMLNode);
  begin
    if (iGraphNode = nil) then
    begin
      iGraphNode := TXMLNode.Create;
      xmlNode.AddChildAsObject (iGraphNode);
    end
    else
    begin
      iGraphNode.DeleteChildren;
    end;
    iGraphNode.TagName := TAG_GRAPH;
    iGraphNode.TagType := ttNormal;
    iGraphNode.Level := xmlNode.Level + 1;
  end;

begin
  grandTotalSumm := 0;
  nofDays := 0;
  totalFlagOn := 0;
  directoryNode := FSelectedTreeNode.Data;

  case (iType) of
    ysWholeQuantity:
      graphNode := xmlNode.GetChild (0);
    ysAverageValue:
      graphNode := xmlNode.GetChild (1);
    ysFirstFlagOn:
      graphNode := xmlNode.GetChild (2);
  end;
  CreateGraphNode (graphNode);

  index := 0;
  for i := 0 to directoryNode.GetNumberOfChildren - 1 do
  begin
    totalSumm := 0;
    firstFlagOn := 0;
    fileNode := directoryNode.GetChild (i);
    if (fileNode.TagName = TAG_FILE) then
    begin
      treeNode := FSelectedTreeNode.Item[index];
      tempStr := fileNode.GetAttributeValue (ATTRIBUTE_PATH);
      journalNode := FXMLPairList.FindJournalByFile (fileNode);
      if ((journalNode = nil) and (tempStr <> UNDEFINED_VALUE)) then
      begin
        xmlParser := FHashTable.GetXMLParser (tempStr);
        for j := 0 to xmlParser.XMLRoot.GetNumberOfChildren - 1 do
        begin
          childNode := xmlParser.XMLRoot.GetChild (j);
          ConvertXMLNodeToTreeNode (treeNode, childNode);
        end;
        treeNode.Data := xmlParser.XMLRoot;
        FXMLPairList.AddOneInstance (fileNode, xmlParser.XMLRoot);
        journalNode := xmlParser.XMLRoot;
      end;

      nofDays := nofDays + journalNode.GetNumberOfChildren;

      for j := 0 to journalNode.GetNumberOfChildren - 1 do
      begin
        dayNode := journalNode.GetChild (j);
        if (dayNode.TagName = TAG_DAY) then
        begin
          nofExperiences := 0;
          for k := 0 to dayNode.GetNumberOfChildren - 1 do
          begin
            experienceNode := dayNode.GetChild (k);
            if (experienceNode.TagName = TAG_EXPERIENCE) then
            begin
              nofExperiences := nofExperiences + 1;
              propertiesNode := experienceNode.FindTagByName (TAG_PROPERTIES);
              if (propertiesNode <> nil) then
              begin
                if ((propertiesNode.GetAttributeValue (ATTRIBUTE_LABEL1) = TRUE_VALUE) or (propertiesNode.GetAttributeValue (ATTRIBUTE_LUCIDDREAM) = TRUE_VALUE)) then
                begin
                  firstFlagOn := firstFlagOn + 1;
                end;
              end;
            end;
          end;
          totalSumm := totalSumm + nofExperiences;
        end;
      end;

      pointNode := TXMLNode.Create;
      pointNode.TagName := TAG_POINT;
      pointNode.TagType := ttShorted;
      graphNode.AddChildAsObject (pointNode);
      pointNode.Level := graphNode.Level + 1;
      pointNode.SetAttributeValue (ATTRIBUTE_NAME, fileNode.GetAttributeValue (ATTRIBUTE_NAME));
      pointNode.SetAttributeValue (ATTRIBUTE_LEFT, IntToStr (index + 1));
      case (iType) of
        ysWholeQuantity:
          begin
            pointNode.SetAttributeValue (ATTRIBUTE_TOP, IntToStr (totalSumm));
          end;
        ysAverageValue:
          begin
            if (journalNode.GetNumberOfChildren = 0) then
            begin
              pointNode.SetAttributeValue (ATTRIBUTE_TOP, '0');
            end
            else
            begin
              pointNode.SetAttributeValue (ATTRIBUTE_TOP, FloatToStr (totalSumm / journalNode.GetNumberOfChildren));
            end
          end;
        ysFirstFlagOn:
          begin
            pointNode.SetAttributeValue (ATTRIBUTE_TOP, IntToStr (firstFlagOn));
          end;
      end;

      index := index + 1;
    end;
    grandTotalSumm := grandTotalSumm + totalSumm;
    totalFlagOn := totalFlagOn + firstFlagOn;
  end;

  case (iType) of
    ysWholeQuantity:
      begin
        graphNode.SetAttributeValue (ATTRIBUTE_HEADER, GRAPH_HEADER_YEAR_1);
        graphNode.SetAttributeValue (ATTRIBUTE_FOOTER, GRAPH_FOOTER_YEAR_1 + IntToStr (grandTotalSumm));
      end;
    ysAverageValue:
      begin
        graphNode.SetAttributeValue (ATTRIBUTE_HEADER, GRAPH_HEADER_YEAR_2);
        if (nofDays = 0) then
        begin
          graphNode.SetAttributeValue (ATTRIBUTE_FOOTER, GRAPH_FOOTER_YEAR_2 + '0');
        end
        else
        begin
          graphNode.SetAttributeValue (ATTRIBUTE_FOOTER, GRAPH_FOOTER_YEAR_2 + FloatToStr (grandTotalSumm / nofDays));
        end;
      end;
    ysFirstFlagOn:
      begin
        graphNode.SetAttributeValue (ATTRIBUTE_HEADER, GRAPH_HEADER_YEAR_3_PART_1 + box_Label1.Caption + GRAPH_HEADER_YEAR_3_PART_2);
        graphNode.SetAttributeValue (ATTRIBUTE_FOOTER, GRAPH_FOOTER_YEAR_3 + IntToStr (totalFlagOn));
      end;
  end;

end;

procedure Tfrm_MainForm.btn_CreateClick (Sender : TObject);
var
  btn : TSpeedButton;
begin
  btn := (Sender as TSpeedButton);
  mnu_Create.Popup (((Width - ClientWidth) div 2) + btn.Left, (Height - ClientHeight) - 3 + btn.Top + btn.Height);
end;

procedure Tfrm_MainForm.FillHTMLEditor (sourceNode : TXMLNode);
var
  tempString : String;
  childNode  : TXMLNode;
begin
  tempString := sourceNode.GetAttributeValue (ATTRIBUTE_NUMBER);
  if (tempString <> UNDEFINED_VALUE) then
  begin
    edt_Number.Text := tempString;
  end
  else
  begin
    edt_Number.Text := '';
  end;

  tempString := sourceNode.GetAttributeValue (ATTRIBUTE_TITLE);
  if (tempString <> UNDEFINED_VALUE) then
  begin
    edt_Name.Text := tempString;
  end
  else
  begin
    edt_Name.Text := '';
  end;

  childNode := sourceNode.FindTagByName (TAG_PROPERTIES);
  if (childNode <> nil) then
  begin
    tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL1);
    if (tempString = TRUE_VALUE) then
    begin
      box_Label1.Checked := True;
    end
    else
    begin
      box_Label1.Checked := False;
      childNode.SetAttributeValue (ATTRIBUTE_LABEL1, FALSE_VALUE);
    end;
    tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL2);
    if (tempString = TRUE_VALUE) then
    begin
      box_Label2.Checked := True;
    end
    else
    begin
      box_Label2.Checked := False;
      childNode.SetAttributeValue (ATTRIBUTE_LABEL2, FALSE_VALUE);
    end;
    tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL3);
    if (tempString = TRUE_VALUE) then
    begin
      box_Label3.Checked := True;
    end
    else
    begin
      box_Label3.Checked := False;
      childNode.SetAttributeValue (ATTRIBUTE_LABEL3, FALSE_VALUE);
    end;
    tempString := childNode.GetAttributeValue (ATTRIBUTE_LABEL4);
    if (tempString = TRUE_VALUE) then
    begin
      box_Label4.Checked := True;
    end
    else
    begin
      box_Label4.Checked := False;
      childNode.SetAttributeValue (ATTRIBUTE_LABEL4, FALSE_VALUE);
    end;
  end
  else
  begin
    box_Label1.Checked := False;
    box_Label2.Checked := False;
    box_Label3.Checked := False;
    box_Label4.Checked := False;
  end;

  childNode := sourceNode.FindTagByName (TAG_ENERGY);
  if (childNode <> nil) then
  begin
    tempString := childNode.GetAttributeValue (ATTRIBUTE_LEVEL);
    if (tempString <> UNDEFINED_VALUE) then
    begin
      trb_Energy.Position := StrToInt (tempString);
      if ((trb_Energy.Position > (trb_Energy.Max - trb_Energy.PageSize) div 2) and (trb_Energy.Position < (trb_Energy.Max + trb_Energy.PageSize) div 2)) then
      begin
        lbl_ZeroEnergyLevel.Font.Color := clRed;
      end;
    end;
  end
  else
  begin
    trb_Energy.Position := trb_Energy.Max div 2;
    lbl_ZeroEnergyLevel.Font.Color := clRed;
  end;

  { DONE 1 -cMethod -oDark Magus :     HTML . }
  pgc_HTMLEditor.ActivePageIndex := 0;
  tempString := sourceNode.GetAttributeValue (ATTRIBUTE_FILE);
  if (tempString <> UNDEFINED_VALUE) then
  begin
    web_HTMLViewer.Navigate (tempString);
    SetHTMLEditorText (tempString);
  end;

end;

procedure Tfrm_MainForm.MakeReadyHTMLEditor;
begin
  img_Graphs.Visible := False;
  lbl_Number.Visible := True;
  lbl_Name.Left := 60;
  lbl_Name.Caption := LABEL_NAME;
  edt_Number.Visible := True;
  edt_Name.Left := 59;
  edt_Name.Width := pnl_WorkArea.Width - 61;
  lbl_Description.Visible := False;
  mmo_Description.Visible := False;
  lbl_Comment.Visible := False;
  mmo_Comment.Visible := False;
  lbl_Image.Visible := False;
  img_Image.Visible := False;
  btn_LoadImage.Visible := False;
  btn_ClearImage.Visible := False;
  if (box_Label1.Caption <> '') then
  begin
    box_Label1.Visible := True;
    if (box_Label2.Caption <> '') then
    begin
      box_Label2.Visible := True;
      if (box_Label3.Caption <> '') then
      begin
        box_Label3.Visible := True;
        if (box_Label4.Caption <> '') then
        begin
          box_Label4.Visible := True;
        end;
      end;
    end;
  end;
  bvl_Border.Top := img_Graphs.Height - 39;
  bvl_Border.Anchors := [akLeft,akRight,akBottom];
  btn_ReadOnly.Visible := True;
  trb_Energy.Height := (box_Label1.Top - trb_Energy.Top) - 29;
  trb_Energy.Visible := True;
  lbl_Energy.Visible := True;
  lbl_HighEnergyLevel.Visible := True;
  lbl_ZeroEnergyLevel.Top := trb_Energy.Top + (trb_Energy.Height - lbl_ZeroEnergyLevel.Height) div 2;
  lbl_ZeroEnergyLevel.Visible := True;
  lbl_LowEnergyLevel.Top := trb_Energy.Top + trb_Energy.Height - lbl_LowEnergyLevel.Height - 6;
  lbl_LowEnergyLevel.Visible := True;
  btn_Copy_1.Visible := False;
  btn_Copy_2.Visible := False;
  btn_Copy_3.Visible := False;
  btn_Refresh_1.Visible := False;
  btn_Refresh_2.Visible := False;
  btn_Refresh_3.Visible := False;

  pnl_HTMLEditor.Visible := True;
end;

procedure Tfrm_MainForm.SetHTMLEditorText (fileName : String);
var
  tempString : String;
  htmlFile   : TextFile;
begin
  AssignFile (htmlFile, fileName);
  Reset (htmlFile);
  if (IOResult = 0) then
  begin
    syn_Editor.Lines.Clear;
    while (not Eof (htmlFile)) do
    begin
      ReadLn (htmlFile, tempString);
      syn_Editor.Lines.Add (tempString);
    end;
  end;
  CloseFile (htmlFile);
end;

function Tfrm_MainForm.GetNewHTMLFileName (id : String) : String;
var
  tempString  : String;
  journalNode : TXMLNode;
  fileNode    : TXMLNode;
  treeNode    : TTreeNode;
  htmlFile    : TextFile;
begin
  treeNode := FSelectedTreeNode.Parent;
  journalNode := treeNode.Data;
  fileNode := FXMLPairList.FindFileByJournal (journalNode);
  tempString := fileNode.GetAttributeValue (ATTRIBUTE_PATH);
  Result := Copy (tempString, 1, Pos ('.', tempString) - 1);
  Result := Result + '_' + id + '.html';
  AssignFile (htmlFile, Result);
  ReWrite (htmlFile);
  CloseFile (htmlFile);
end;

procedure Tfrm_MainForm.pgc_HTMLEditorChanging (Sender : TObject; var AllowChange : Boolean);
begin
  case ((Sender as TPageControl).ActivePageIndex) of
    0: // EDITOR
      begin
      end;
    1: // BROWSER
      begin
        btn_HTML_SaveClick (nil);
      end;
  end;
end;

procedure Tfrm_MainForm.btn_HTML_NewClick (Sender : TObject);
begin
  syn_Editor.SelectAll;
  syn_Editor.SelText :=
    '<html>'#13#10 +
    '<head>'#13#10 +
    '    <title></title>'#13#10 +
    '</head>'#13#10 +
    '<body>'#13#10 +
    #13#10#13#10#13#10 +
    '</body>'#13#10 +
    '</html>';
end;

procedure Tfrm_MainForm.btn_HTML_SaveClick (Sender : TObject);
var
  tempString     : String;
  st             : TStringList;
  experienceNode : TXMLNode;
begin
  st := nil;
  try
    experienceNode := FSelectedTreeNode.Data;
    tempString := experienceNode.GetAttributeValue (ATTRIBUTE_FILE);
    if (tempString <> UNDEFINED_VALUE) then
    begin
      st := TStringList.Create;
      st.Text := syn_Editor.Lines.Text;
      st.SaveToFile (tempString);                   
      web_HTMLViewer.Navigate (tempString);
    end;
  finally
    if (Assigned (st)) then
    begin
      st.Free;
    end;
  end;
end;

procedure Tfrm_MainForm.btn_HTML_UndoClick (Sender : TObject);
begin
  syn_Editor.Undo;
end;

procedure Tfrm_MainForm.InsertTags (tag1, tag2 : String);
begin
  syn_Editor.SelText := tag1 + syn_Editor.SelText + tag2;
end;

procedure Tfrm_MainForm.btn_HTML_BoldClick (Sender : TObject);
begin
  InsertTags ('<b>','</b>');
end;

procedure Tfrm_MainForm.btn_HTML_ItalicClick (Sender : TObject);
begin
  InsertTags ('<i>','</i>');
end;

procedure Tfrm_MainForm.btn_HTML_UnderlinedClick (Sender : TObject);
begin
  InsertTags ('<u>','</u>');
end;

procedure Tfrm_MainForm.btn_HTML_PClick (Sender : TObject);
begin
  InsertTags ('<p>','</p>');
end;

procedure Tfrm_MainForm.btn_HTML_BRClick (Sender : TObject);
begin
  InsertTags ('<br>','');
end;

procedure Tfrm_MainForm.btn_HTML_AClick (Sender : TObject);
begin
  InsertTags ('<a href="">','</a>');
end;

procedure Tfrm_MainForm.btn_HTML_IMGClick (Sender : TObject);
begin
  InsertTags ('<img src="">','');
end;

procedure Tfrm_MainForm.btn_ViewInBrowserClick (Sender : TObject);
var
  parameter   : String;
  tempNode    : TXMLNode;
  fileNode    : TXMLNode;
  libraryNode : TXMLNode;
begin
  parameter := UNDEFINED_VALUE;
  tempNode := FSelectedTreeNode.Data;

  if (tempNode.TagName = TAG_DREAMLIBRARY) then
  begin
    libraryNode := FINIFile.FindTagByName (TAG_LIBRARY);
    if (libraryNode <> nil) then
    begin
      parameter := libraryNode.GetAttributeValue (ATTRIBUTE_PATH);
    end;
  end;

  if ((tempNode.TagName = TAG_DREAMJOURNAL) or (tempNode.TagName = TAG_FILE)) then
  begin
    fileNode := FXMLPairList.FindFileByJournal (tempNode);
    parameter := fileNode.GetAttributeValue (ATTRIBUTE_PATH);
  end;

  if (parameter <> UNDEFINED_VALUE) then
  begin
    ShellExecute (Application.Handle, 'open', 'iexplore.exe', PChar (parameter), nil, SW_NORMAL);
  end;
end;

procedure Tfrm_MainForm.btn_NewClick (Sender : TObject);
var
  path           : String;
  libraryNode    : TXMLNode;
  newLibraryForm : Tfrm_NewElement;
begin
  newLibraryForm := Tfrm_NewElement.Create (Application);
  newLibraryForm.SetInterface (cfDreamLibrary);
  if (newLibraryForm.ShowModal = mrOk) then
  begin
    path := newLibraryForm.edt_Second.Text;
    FLibraryFile.SaveFile (FLibraryFile.FileName);
    FLibraryFile.Free;
    FLibraryFile := TXMLParser.Create;
    FLibraryFile.XMLParameters.XMLEncoding := XML_ENCODING;
    FLibraryFile.XMLParameters.XMLStyleSheet := DREAM_LIBRARY_STYLESHEET;
    FLibraryFile.XMLParameters.XMLDocType.DocTypeDefinition := DREAM_LIBRARY_DOCTYPE;
    FLibraryFile.XMLRoot.TagName := TAG_DREAMLIBRARY;
    FLibraryFile.XMLRoot.SetAttributeValue (ATTRIBUTE_NAME, newLibraryForm.edt_First.Text);
    FLibraryFile.SaveFile (path);
    FTag := True;
    tre_Directory.Items.Clear;
    FTag := False;
    FSelectedTreeNode := nil;
    FCurrentFileNode := nil;
    libraryNode := FINIFile.XMLRoot.FindTagByName (TAG_LIBRARY);
    if (libraryNode <> nil) then
    begin
      libraryNode.SetAttributeValue (ATTRIBUTE_PATH, path);
    end
    else
    begin
      libraryNode := TXMLNode.Create;
      libraryNode.TagName := TAG_LIBRARY;
      libraryNode.TagType := ttShorted;
      libraryNode.SetAttributeValue (ATTRIBUTE_PATH, path);
      FINIFile.XMLRoot.AddChildAsObject (libraryNode);
      libraryNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
    ProcessLibraryFile (path);
    tre_Directory.Items[0].Selected := True;
  end;
  newLibraryForm.Free;
end;

procedure Tfrm_MainForm.btn_OpenClick (Sender : TObject);
var
  path        : String;
  libraryNode : TXMLNode;
begin
  dlg_OpenImage.Title := CAPTION_OPEN_LIBRARY;
  dlg_OpenImage.Filter := FILTER_LIBRARY;
  if (dlg_OpenImage.Execute) then
  begin
    path := dlg_OpenImage.FileName;
    FLibraryFile.SaveFile (FLibraryFile.FileName);
    FLibraryFile.Free;
    FLibraryFile := TXMLParser.Create;
    FTag := True;
    tre_Directory.Items.Clear;
    FTag := False;
    FSelectedTreeNode := nil;
    FCurrentFileNode := nil;
    libraryNode := FINIFile.XMLRoot.FindTagByName (TAG_LIBRARY);
    if (libraryNode <> nil) then
    begin
      libraryNode.SetAttributeValue (ATTRIBUTE_PATH, path);
    end
    else
    begin
      libraryNode := TXMLNode.Create;
      libraryNode.TagName := TAG_LIBRARY;
      libraryNode.TagType := ttShorted;
      libraryNode.SetAttributeValue (ATTRIBUTE_PATH, path);
      FINIFile.XMLRoot.AddChildAsObject (libraryNode);
      libraryNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
    ProcessLibraryFile (path);
  end;
  dlg_OpenImage.Title := CAPTION_OPEN_IMAGE;
  dlg_OpenImage.Filter := FILTER_IMAGE;
end;

procedure Tfrm_MainForm.mnu_SaveAsClick (Sender : TObject);
var
  path        : String;
  libraryNode : TXMLNode;
begin
  dlg_Save.Title := CAPTION_SAVE_LIBRARY;
  dlg_Save.Filter := FILTER_LIBRARY;
  if (dlg_Save.Execute) then
  begin
    path := dlg_Save.FileName;
    FLibraryFile.SaveFile (path);
    libraryNode := FINIFile.XMLRoot.FindTagByName (TAG_LIBRARY);
    if (libraryNode <> nil) then
    begin
      libraryNode.SetAttributeValue (ATTRIBUTE_PATH, path);
    end
    else
    begin
      libraryNode := TXMLNode.Create;
      libraryNode.TagName := TAG_LIBRARY;
      libraryNode.TagType := ttShorted;
      libraryNode.SetAttributeValue (ATTRIBUTE_PATH, path);
      FINIFile.XMLRoot.AddChildAsObject (libraryNode);
      libraryNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
  end;
end;

procedure Tfrm_MainForm.mnu_OptionsClick (Sender : TObject);
var
  i              : Integer;
  index          : Integer;
  icon           : Integer;
  tempStr        : String;
  iconName       : array[1..6] of String;
  edt_Labels     : array[1..4] of TEdit;
  edt_Icons      : array[1..6] of TEdit;
  tempNode       : TXMLNode;
  parametersForm : Tfrm_ParametersForm;

  libraryNode    : TXMLNode;
  optionsNode    : TXMLNode;
  userNode       : TXMLNode;
  additionalNode : TXMLNode;
  formNode       : TXMLNode;
  labelNode      : array[1..4] of TXMLNode;
  iconNode       : array[1..6] of TXMLNode;
begin
  parametersForm := Tfrm_ParametersForm.Create (Application);
  edt_Labels[1] := parametersForm.edt_Label_1;
  edt_Labels[2] := parametersForm.edt_Label_2;
  edt_Labels[3] := parametersForm.edt_Label_3;
  edt_Labels[4] := parametersForm.edt_Label_4;
  edt_Icons[1] := parametersForm.edt_OpenNode;
  edt_Icons[2] := parametersForm.edt_Library;
  edt_Icons[3] := parametersForm.edt_Directory;
  edt_Icons[4] := parametersForm.edt_File;
  edt_Icons[5] := parametersForm.edt_Night;
  edt_Icons[6] := parametersForm.edt_Experience;
  iconName[1] :=  STR_OPENED_NODE;
  iconName[2] :=  STR_DREAM_LIBRARY;
  iconName[3] :=  STR_DREAM_DIRECTORY;
  iconName[4] :=  STR_DREAM_FILE;
  iconName[5] :=  STR_ONE_NIGHT;
  iconName[6] :=  STR_ONE_DREAM;

  parametersForm.upd_XCoordinate.Position := Left;
  parametersForm.upd_YCoordinate.Position := Top;
  parametersForm.upd_Width.Position := Width;
  parametersForm.upd_Height.Position := Height;
  parametersForm.upd_TreeWidth.Position := tre_Directory.Width;
  libraryNode := FINIFile.XMLRoot.FindTagByName (TAG_LIBRARY);
  if (libraryNode <> nil) then
  begin
    tempStr := libraryNode.GetAttributeValue (ATTRIBUTE_PATH);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.edt_LibraryFileName.Text := tempStr;
    end;
  end;
  index := 1;
  icon := 1;
  for i := 0 to FINIFile.XMLRoot.GetNumberOfChildren - 1 do
  begin
    tempNode := FINIFile.XMLRoot.GetChild (i);
    if (tempNode.TagName = TAG_LABEL) then
    begin
      labelNode[index] := tempNode;
      tempStr := tempNode.GetAttributeValue (ATTRIBUTE_CAPTION);
      if (tempStr <> UNDEFINED_VALUE) then
      begin
        edt_Labels[index].Text := tempStr;
      end;
      index := index + 1;
      Continue;
    end;
    if (tempNode.TagName = TAG_ICON) then
    begin
      iconNode[icon] := tempNode;
      tempStr := tempNode.GetAttributeValue (ATTRIBUTE_PATH);
      if (tempStr <> UNDEFINED_VALUE) then
      begin
        edt_Icons[icon].Text := tempStr;
      end;
      icon := icon + 1;
      Continue;
    end;
  end;
  optionsNode := FINIFile.XMLRoot.FindTagByName (TAG_OPTIONS);
  if (optionsNode <> nil) then
  begin
    parametersForm.box_Delete.Checked := (optionsNode.GetAttributeValue (ATTRIBUTE_CONFIRMDELETE) = STR_YES);
  end;
  userNode := FLibraryFile.XMLRoot.FindTagByName (TAG_USER);
  if (userNode <> nil) then
  begin
    tempStr := userNode.GetAttributeValue (ATTRIBUTE_NAME);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.edt_Name.Text := tempStr;
    end;
    tempStr := userNode.GetAttributeValue (ATTRIBUTE_NICK);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.edt_Nick.Text := tempStr;
    end;
    tempStr := userNode.GetAttributeValue (ATTRIBUTE_EMAIL);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.edt_EMail.Text := tempStr;
    end;
    tempStr := userNode.GetAttributeValue (ATTRIBUTE_SEX);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.rab_Masculinum.Checked := (tempStr = STR_MASCULINUM);
      parametersForm.rab_Femininum.Checked := (tempStr = STR_FEMININUM);
      parametersForm.rab_Smile.Checked := (tempStr = STR_SMILE);
    end;
    tempStr := userNode.GetAttributeValue (ATTRIBUTE_AGE);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.upd_Age.Position := StrToInt (tempStr);
    end;
    if (userNode.GetChild (0) <> nil) then
    begin
      parametersForm.mmo_AdditionalNotes.Text := userNode.GetChild (0).TextData;
    end;
  end;
  additionalNode := FLibraryFile.XMLRoot.FindTagByName (TAG_ADDITIONAL);
  if (additionalNode <> nil) then
  begin
    tempStr := additionalNode.GetAttributeValue (ATTRIBUTE_DICTIONARY);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.edt_Dictionary.Text := tempStr;
    end;
    tempStr := additionalNode.GetAttributeValue (ATTRIBUTE_VOCABULARY);
    if (tempStr <> UNDEFINED_VALUE) then
    begin
      parametersForm.edt_DreamVocabulary.Text := tempStr;
    end;
  end;

  if (parametersForm.ShowModal = mrOk) then
  begin
    formNode := FINIFile.XMLRoot.FindTagByName (TAG_FORM);
    if (formNode = nil) then
    begin
      formNode := TXMLNode.Create;
      formNode.TagName := TAG_FORM;
      formNode.TagType := ttShorted;
      FINIFile.XMLRoot.AddChildAsObject (formNode);
      formNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
    formNode.SetAttributeValue (ATTRIBUTE_LEFT, parametersForm.edt_XCoordinate.Text);
    formNode.SetAttributeValue (ATTRIBUTE_TOP, parametersForm.edt_YCoordinate.Text);
    formNode.SetAttributeValue (ATTRIBUTE_WIDTH, parametersForm.edt_Width.Text);
    formNode.SetAttributeValue (ATTRIBUTE_HEIGHT, parametersForm.edt_Height.Text);
    formNode.SetAttributeValue (ATTRIBUTE_TREE_WIDTH, parametersForm.edt_TreeWidth.Text);
    Left := StrToInt (parametersForm.edt_XCoordinate.Text);
    Top := StrToInt (parametersForm.edt_YCoordinate.Text);
    Width := StrToInt (parametersForm.edt_Width.Text);
    Height := StrToInt (parametersForm.edt_Height.Text);
    tre_Directory.Width := StrToInt (parametersForm.edt_TreeWidth.Text);
    if (libraryNode = nil) then
    begin
      libraryNode := TXMLNode.Create;
      libraryNode.TagName := TAG_LIBRARY;
      libraryNode.TagType := ttShorted;
      FINIFile.XMLRoot.AddChildAsObject (libraryNode);
      libraryNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
    libraryNode.SetAttributeValue (ATTRIBUTE_PATH, parametersForm.edt_LibraryFileName.Text);
    for i := 1 to 4 do
    begin
      if (labelNode[i] = nil) then
      begin
        labelNode[i] := TXMLNode.Create;
        labelNode[i].TagName := TAG_LABEL;
        labelNode[i].TagType := ttShorted;
        FINIFile.XMLRoot.AddChildAsObject (labelNode[i]);
        labelNode[i].Level := FINIFile.XMLRoot.Level + 1;
      end;
      if (edt_Labels[i].Text = '') then
      begin
        FINIFile.XMLRoot.DeleteChild (FINIFile.XMLRoot.GetChildNumber (labelNode[i]));
      end
      else
      begin
        labelNode[i].SetAttributeValue (ATTRIBUTE_CAPTION, edt_Labels[i].Text);
      end;
    end;
    box_Label1.Caption := edt_Labels[1].Text;
    box_Label2.Caption := edt_Labels[2].Text;
    box_Label3.Caption := edt_Labels[3].Text;
    box_Label4.Caption := edt_Labels[4].Text;
    for i := 1 to 6 do
    begin
      if (iconNode[i] = nil) then
      begin
        iconNode[i] := TXMLNode.Create;
        iconNode[i].TagName := TAG_LABEL;
        iconNode[i].TagType := ttShorted;
        FINIFile.XMLRoot.AddChildAsObject (iconNode[i]);
        iconNode[i].Level := FINIFile.XMLRoot.Level + 1;
      end;
      iconNode[i].SetAttributeValue (ATTRIBUTE_NAME, iconName[i]);
      iconNode[i].SetAttributeValue (ATTRIBUTE_CAPTION, edt_Icons[i].Text);
    end;
    if (optionsNode = nil) then
    begin
      optionsNode := TXMLNode.Create;
      optionsNode.TagName := TAG_OPTIONS;
      optionsNode.TagType := ttShorted;
      FINIFile.XMLRoot.AddChildAsObject (optionsNode);
      optionsNode.Level := FINIFile.XMLRoot.Level + 1;
    end;
    if (parametersForm.box_Delete.Checked) then
    begin
      optionsNode.SetAttributeValue (ATTRIBUTE_CONFIRMDELETE, STR_YES);
    end
    else
    begin
      optionsNode.SetAttributeValue (ATTRIBUTE_CONFIRMDELETE, STR_NO);
    end;
    if (userNode = nil) then
    begin
      userNode := TXMLNode.Create;
      userNode.TagName := TAG_USER;
      FLibraryFile.XMLRoot.AddChildAsObject (userNode);
      userNode.Level := FLibraryFile.XMLRoot.Level + 1;
    end;
    userNode.SetAttributeValue (ATTRIBUTE_NAME, parametersForm.edt_Name.Text);
    userNode.SetAttributeValue (ATTRIBUTE_NICK, parametersForm.edt_Nick.Text);
    userNode.SetAttributeValue (ATTRIBUTE_EMAIL, parametersForm.edt_EMail.Text);
    userNode.SetAttributeValue (ATTRIBUTE_AGE, IntToStr (parametersForm.upd_Age.Position));
    if (parametersForm.rab_Masculinum.Checked) then
    begin
      userNode.SetAttributeValue (ATTRIBUTE_SEX, STR_MASCULINUM);
    end
    else
    begin
      if (parametersForm.rab_Femininum.Checked) then
      begin
        userNode.SetAttributeValue (ATTRIBUTE_SEX, STR_FEMININUM);
      end
      else
      begin
        userNode.SetAttributeValue (ATTRIBUTE_SEX, STR_SMILE);
      end;
    end;
    if (parametersForm.mmo_AdditionalNotes.Text <> '') then
    begin
      if (userNode.GetChild (0) = nil) then
      begin
        tempNode := TXMLNode.Create;
        tempNode.TagType := ttCDATA;
        tempNode.TextData := parametersForm.mmo_AdditionalNotes.Text;
        userNode.AddChildAsObject (tempNode);
      end
      else
      begin
        userNode.GetChild (0).TextData := parametersForm.mmo_AdditionalNotes.Text;
      end;
    end
    else
    begin
      if (userNode.GetChild (0) <> nil) then
      begin
        userNode.DeleteChild (0);
      end;
    end;
    if (additionalNode = nil) then
    begin
      additionalNode := TXMLNode.Create;
      additionalNode.TagName := TAG_ADDITIONAL;
      additionalNode.TagType := ttShorted;
      FLibraryFile.XMLRoot.AddChildAsObject (additionalNode);
      additionalNode.Level := FLibraryFile.XMLRoot.Level + 1;
    end;
    additionalNode.SetAttributeValue (ATTRIBUTE_DICTIONARY, parametersForm.edt_Dictionary.Text);
    additionalNode.SetAttributeValue (ATTRIBUTE_VOCABULARY, parametersForm.edt_DreamVocabulary.Text);
  end;
  parametersForm.Free;
end;

procedure Tfrm_MainForm.btn_DreamPropertiesClick (Sender : TObject);
var
  dreamNode      : TXMLNode;
  propertiesNode : TXMLNode;
begin
  FDreamPropertiesForm.Left := 2 + Left + pnl_WorkArea.Left + btn_DreamProperties.Left;
  FDreamPropertiesForm.Top := 42 + Top + pnl_WorkArea.Top + btn_DreamProperties.Top + btn_DreamProperties.Height + 2;
  dreamNode := FSelectedTreeNode.Data;
  propertiesNode := dreamNode.FindTagByName (TAG_PROPERTIES);
  FDreamPropertiesForm.ClearControls (FDreamPropertiesForm.pnl_WorkArea);
  FDreamPropertiesForm.FillIn (propertiesNode, FDreaMPropertiesForm.pnl_WorkArea);
  if (FDreamPropertiesForm.ShowModal = mrOk) then
  begin
    if (propertiesNode = nil) then
    begin
      propertiesNode := TXMLNode.Create;
      propertiesNode.TagName := TAG_PROPERTIES;
      dreamNode.AddChildAsObject (propertiesNode);
      propertiesNode.Level := dreamNode.Level + 1;
    end;

    FDreamPropertiesForm.SaveInfo (propertiesNode, FDreaMPropertiesForm.pnl_WorkArea);
  end;
end;

procedure Tfrm_MainForm.mnu_RefreshAllClick (Sender : TObject);
begin
  btn_Refresh_1Click (Sender);
  btn_Refresh_2Click (Sender);
  btn_Refresh_3Click (Sender);
end;

procedure Tfrm_MainForm.mnu_ExportClick (Sender : TObject);
var
  xmlNode    : TXMLNode;
  exportFile : TextFile;
  exporter   : TExporter;
begin
  exporter := nil;
  xmlNode := FSelectedTreeNode.Data;
  dlg_Save.Title := CAPTION_EXPORT;
  dlg_Save.Filter := FILTER_EXPORT;
  if (dlg_Save.Execute) then
  begin
    AssignFile (exportFile, dlg_Save.FileName);
    ReWrite (exportFile);
    case (dlg_Save.FilterIndex) of
      1:
        begin
          exporter := THTMLExporter.Create;
        end;
      2:
        begin
          exporter := TTXTExporter.Create;
        end;
    end;
    exporter.Flag_1 := box_Label1.Caption;
    exporter.Flag_2 := box_Label2.Caption;
    exporter.Flag_3 := box_Label3.Caption;
    exporter.Flag_4 := box_Label4.Caption;

    exporter.ExportNode (xmlNode, exportFile);
    CloseFile (exportFile);
  end;
end;

procedure Tfrm_MainForm.mnu_ShowHelpClick (Sender : TObject);
begin
  ShellExecute (Application.Handle, 'open', 'Help/index.html', nil, nil, SW_NORMAL);
end;

procedure Tfrm_MainForm.mnu_RegisterClick (Sender : TObject);
begin
  ShellExecute (Application.Handle, 'open', 'http://www.dreamer.ru/dj_register.shtml', nil, nil, SW_NORMAL);
end;

procedure Tfrm_MainForm.mnu_InternetClick (Sender : TObject);
begin
  ShellExecute (Application.Handle, 'open', 'http://www.dreamer.ru/', nil, nil, SW_NORMAL);
end;

//-[ END ]---------------------------------------------------------------------
end.
