//***************************************************************************//
//*                                                                         *//
//* Unit:    drj_Resources                                                  *//
//* Author:  Dark Magus                                                     *//
//* Date:    21.08.01                                                       *//
//*                                                                         *//
//*      " "  Dream Journal      *//
//* (v. 2.0).                                                               *//
//*                                                                         *//
//***************************************************************************//
unit drj_NewElementForm;

//-[ INTERFACE ]---------------------------------------------------------------
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,

  drj_Types,
  drj_Resources, Buttons, ExtCtrls;

type Tfrm_NewElement = class (TForm)
    btn_Ok          : TButton;
    btn_Cancel      : TButton;
    edt_First       : TEdit;
    edt_Second      : TEdit;
    lbl_First       : TLabel;
    lbl_Second      : TLabel;
    btn_Default     : TSpeedButton;
    dlg_SaveFile    : TSaveDialog;
    rdg_DreamOption : TRadioGroup;
    procedure edt_FirstChange (Sender : TObject);
    procedure btn_DefaultClick (Sender : TObject);
  private
    FNextNumber : Integer;
    FGivenFlag  : TControlsFlag;

    procedure SetItemIndex (index : Integer);

    function GetItemIndex : Integer;

  public
    property NextNumber : Integer read FNextNumber write FNextNumber;
    property ItemIndex  : Integer read GetItemIndex write SetItemIndex;

    procedure SetInterface (flag : TControlsFlag);

end;

//-[ IMPLEMENTATION ]----------------------------------------------------------
implementation

{$R *.DFM}

procedure Tfrm_NewElement.SetInterface (flag : TControlsFlag);
var
  tempString : String;
begin
  FGivenFlag := flag;
  case (FGivenFlag) of
    cfDreamLibrary:
      begin
        Height := 127;
        Caption := CAPTION_LIBRARY;
        lbl_First.Caption := LABEL_NAME;
        edt_First.Width := 150;
        lbl_Second.Caption := LABEL_PATH;
        btn_Default.Visible := False;
        edt_Second.Width := 127;
        btn_Default.Hint := HINT_OPEN_FILE;
        btn_Default.Top := 38;
        btn_Default.Visible := True;
        btn_Ok.Top := 68;
        btn_Cancel.Top := 68;
        rdg_DreamOption.Visible := False;
        dlg_SaveFile.Filter := FILTER_LIBRARY;
      end;
    cfDirectory:
      begin
        Height := 103;
        Caption := CAPTION_CATALOGUE;
        lbl_First.Caption := LABEL_NAME;
        edt_First.Width := 150;
        btn_Default.Visible := False;
        lbl_Second.Visible := False;
        edt_Second.Visible := False;
        btn_Ok.Top := 43;
        btn_Cancel.Top := 43;
        rdg_DreamOption.Visible := False;
      end;
    cfDreamJournal:
      begin
        Height := 127;
        Caption := CAPTION_FILE;
        lbl_First.Caption := LABEL_NAME;
        edt_First.Width := 150;
        lbl_Second.Caption := LABEL_PATH;
        btn_Default.Visible := False;
        edt_Second.Width := 127;
        btn_Default.Hint := HINT_OPEN_FILE;
        btn_Default.Top := 38;
        btn_Default.Visible := True;
        btn_Ok.Top := 68;
        btn_Cancel.Top := 68;
        rdg_DreamOption.Visible := False;
        dlg_SaveFile.Filter := FILTER_JOURNAL;
      end;
    cfOneNight:
      begin
        Height := 103;
        Caption := CAPTION_DAY;
        lbl_First.Caption := LABEL_DATE;
        lbl_Second.Visible := False;
        edt_Second.Visible := False;
        btn_Ok.Top := 43;
        btn_Cancel.Top := 43;
        btn_Default.Hint := HINT_CURRENT_DATE;
        rdg_DreamOption.Visible := False;
      end;
    cfOneDream:
      begin
        Height := 193;
        Caption := CAPTION_EXPERIENCE;
        edt_First.Width := 150;
        lbl_First.Caption := LABEL_NUMBER;
        lbl_Second.Caption := LABEL_NAME;
        btn_Default.Visible := False;
        tempString := IntToStr (FNextNumber);
        case (Length (tempString)) of
          1:
            begin
              tempString := '00' + tempString;
            end;
          2:
            begin
              tempString := '0' + tempString;
            end;
        end;
        edt_First.Text := tempString;
        btn_Ok.Top := 134;
        btn_Cancel.Top := 134;
        rdg_DreamOption.Visible := True;
      end;
  end;
end;

procedure Tfrm_NewElement.edt_FirstChange (Sender : TObject);
begin
  if ((FGivenFlag = cfDirectory) or (FGivenFlag = cfOneNight)) then
  begin
    btn_Ok.Enabled := (edt_First.Text <> '');
  end
  else
  begin
    btn_Ok.Enabled := ((edt_First.Text <> '') and (edt_Second.Text <> ''));
  end;
end;

procedure Tfrm_NewElement.btn_DefaultClick (Sender : TObject);
begin
  case (FGivenFlag) of
    cfDreamLibrary:
      begin
        if (dlg_SaveFile.Execute) then
        begin
          edt_Second.Text := dlg_SaveFile.FileName;
        end;
      end;
    cfDirectory:
      begin
      end;
    cfDreamJournal:
      begin
        if (dlg_SaveFile.Execute) then
        begin
          edt_Second.Text := dlg_SaveFile.FileName;
        end;
      end;
    cfOneNight:
      begin
        edt_First.Text := DateToStr (Date);
      end;
    cfOneDream:
      begin
      end;
  end;
end;

procedure Tfrm_NewElement.SetItemIndex (index : Integer);
begin
  rdg_DreamOption.ItemIndex := index;
end;

function Tfrm_NewElement.GetItemIndex : Integer;
begin
  Result := rdg_DreamOption.ItemIndex;
end;

//-[ END ]---------------------------------------------------------------------
end.
