//***************************************************************************//
//*                                                                         *//
//* Unit:    drj_ParametersForm                                             *//
//* Author:  Dark Magus                                                     *//
//* Date:    22.12.01                                                       *//
//*                                                                         *//
//*         ( ,      *//
//*   ).                                      *//
//*                                                                         *//
//***************************************************************************//
unit drj_ParametersForm;

//-[ INTERFACE ]---------------------------------------------------------------
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons,

  drj_Resources, ExtCtrls;

type Tfrm_ParametersForm = class (TForm)
    btn_Cancel           : TButton;
    btn_Ok               : TButton;
    pgc_Pages            : TPageControl;
    tab_General          : TTabSheet;
    tab_Interface        : TTabSheet;
    tab_Confirmations    : TTabSheet;
    tab_User             : TTabSheet;
    grp_MainForm         : TGroupBox;
    tab_Additional       : TTabSheet;
    lbl_XCoordinate      : TLabel;
    edt_XCoordinate      : TEdit;
    upd_XCoordinate      : TUpDown;
    lbl_Width            : TLabel;
    edt_Width            : TEdit;
    upd_Width            : TUpDown;
    lbl_YCoordinate      : TLabel;
    edt_YCoordinate      : TEdit;
    upd_YCoordinate      : TUpDown;
    lbl_Height           : TLabel;
    edt_Height           : TEdit;
    upd_Height           : TUpDown;
    lbl_TreeWidth        : TLabel;
    edt_TreeWidth        : TEdit;
    upd_TreeWidth        : TUpDown;
    lbl_LibraryFileName  : TLabel;
    edt_LibraryFileName  : TEdit;
    btn_LibraryFileName  : TSpeedButton;
    dlg_OpenFile         : TOpenDialog;
    grp_Icons            : TGroupBox;
    lbl_OpenNode         : TLabel;
    lbl_Library          : TLabel;
    lbl_Directory        : TLabel;
    edt_OpenNode         : TEdit;
    btn_OpenNode         : TSpeedButton;
    edt_Library          : TEdit;
    btn_Library          : TSpeedButton;
    edt_Directory        : TEdit;
    btn_Directory        : TSpeedButton;
    lbl_File             : TLabel;
    edt_File             : TEdit;
    btn_File             : TSpeedButton;
    lbl_Night            : TLabel;
    edt_Night            : TEdit;
    btn_Night            : TSpeedButton;
    lbl_Experience       : TLabel;
    edt_Experience       : TEdit;
    btn_Experience       : TSpeedButton;
    grp_Labels           : TGroupBox;
    lbl_Label_1          : TLabel;
    edt_Label_1          : TEdit;
    lbl_Label_2          : TLabel;
    edt_Label_2          : TEdit;
    lbl_Label_3          : TLabel;
    lbl_Label_4          : TLabel;
    edt_Label_3          : TEdit;
    edt_Label_4          : TEdit;
    grp_Confirmations    : TGroupBox;
    box_Delete           : TCheckBox;
    lbl_Name             : TLabel;
    edt_Name             : TEdit;
    lbl_Nick             : TLabel;
    edt_Nick: TEdit;
    lbl_EMail            : TLabel;
    edt_EMail            : TEdit;
    lbl_AdditionalNotes  : TLabel;
    mmo_AdditionalNotes  : TMemo;
    lbl_Age              : TLabel;
    edt_Age              : TEdit;
    upd_Age              : TUpDown;
    grp_Sex              : TGroupBox;
    rab_Masculinum       : TRadioButton;
    rab_Femininum        : TRadioButton;
    rab_Smile            : TRadioButton;
    grp_AdditionalData: TGroupBox;
    lbl_Dictionary: TLabel;
    edt_Dictionary: TEdit;
    lbl_DreamVocabulary: TLabel;
    edt_DreamVocabulary: TEdit;
    btn_Dictionary: TSpeedButton;
    btn_DreamVocabulary: TSpeedButton;
    procedure FormCreate (Sender : TObject);
    procedure btn_LibraryFileNameClick (Sender : TObject);
    procedure btn_OpenNodeClick (Sender : TObject);
    procedure btn_LibraryClick (Sender : TObject);
    procedure btn_DirectoryClick (Sender : TObject);
    procedure btn_FileClick (Sender : TObject);
    procedure btn_NightClick (Sender : TObject);
    procedure btn_ExperienceClick (Sender : TObject);
    procedure btn_DictionaryClick (Sender : TObject);
    procedure btn_DreamVocabularyClick (Sender : TObject);
  private
  public
end;

//-[ IMPLEMENTATION ]----------------------------------------------------------
implementation

{$R *.DFM}

procedure Tfrm_ParametersForm.FormCreate (Sender : TObject);
begin
  pgc_Pages.ActivePageIndex := 0;

  upd_XCoordinate.Max := Screen.Width;
  upd_Width.Max := Screen.Width;
  upd_YCoordinate.Max := Screen.Height;
  upd_Height.Max := Screen.Height;
  upd_TreeWidth.Max := Screen.Width div 2;
end;

procedure Tfrm_ParametersForm.btn_LibraryFileNameClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_LIBRARY;
  dlg_OpenFile.FileName := edt_LibraryFileName.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_LibraryFileName.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_OpenNodeClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_IMAGE;
  dlg_OpenFile.FileName := edt_OpenNode.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_OpenNode.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_LibraryClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_IMAGE;
  dlg_OpenFile.FileName := edt_Library.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_Library.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_DirectoryClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_IMAGE;
  dlg_OpenFile.FileName := edt_Directory.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_Directory.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_FileClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_IMAGE;
  dlg_OpenFile.FileName := edt_File.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_File.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_NightClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_IMAGE;
  dlg_OpenFile.FileName := edt_Night.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_Night.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_ExperienceClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_IMAGE;
  dlg_OpenFile.FileName := edt_Experience.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_Experience.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_DictionaryClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_EXTERNAL_FILE;
  dlg_OpenFile.FileName := edt_Dictionary.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_Dictionary.Text := dlg_OpenFile.FileName;
  end;
end;

procedure Tfrm_ParametersForm.btn_DreamVocabularyClick (Sender : TObject);
begin
  dlg_OpenFile.Filter := FILTER_EXTERNAL_FILE;
  dlg_OpenFile.FileName := edt_DreamVocabulary.Text;
  if (dlg_OpenFile.Execute) then
  begin
    edt_DreamVocabulary.Text := dlg_OpenFile.FileName;
  end;
end;

//-[ END ]---------------------------------------------------------------------
end.
